/* Manager.c generated by valac 0.56.17, the Vala compiler
 * generated from Manager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "bluetooth.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>
#include <gtk/gtk.h>

#define BLUETOOTH_SERVICES_OBJECT_MANAGER_SCHEMA "io.elementary.desktop.wingpanel.bluetooth"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef GDBusProxy BluetoothServicesAgentManagerProxy;
typedef GDBusProxyClass BluetoothServicesAgentManagerProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BLUETOOTH_SERVICES_OBJECT_MANAGER_0_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_DISCOVERABLE_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_HAS_OBJECT_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_RETRIEVE_FINISHED_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_DISCOVERING_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_POWERED_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_CONNECTED_PROPERTY,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_NUM_PROPERTIES
};
static GParamSpec* bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothServicesObjectManagerCreateManagerData BluetoothServicesObjectManagerCreateManagerData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _BluetoothServicesObjectManagerCreateAgentData BluetoothServicesObjectManagerCreateAgentData;
typedef struct _BluetoothServicesObjectManagerRegisterAgentData BluetoothServicesObjectManagerRegisterAgentData;
typedef struct _BluetoothServicesObjectManagerUnregisterAgentData BluetoothServicesObjectManagerUnregisterAgentData;
typedef struct _BluetoothServicesObjectManagerStartDiscoveryData BluetoothServicesObjectManagerStartDiscoveryData;
typedef struct _BluetoothServicesObjectManagerStopDiscoveryData BluetoothServicesObjectManagerStopDiscoveryData;
typedef struct _BluetoothServicesObjectManagerSetGlobalStateData BluetoothServicesObjectManagerSetGlobalStateData;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
enum  {
	BLUETOOTH_SERVICES_OBJECT_MANAGER_ADAPTER_ADDED_SIGNAL,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_ADAPTER_REMOVED_SIGNAL,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_DEVICE_ADDED_SIGNAL,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_DEVICE_REMOVED_SIGNAL,
	BLUETOOTH_SERVICES_OBJECT_MANAGER_NUM_SIGNALS
};
static guint bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_NUM_SIGNALS] = {0};

struct _BluetoothServicesObjectManagerPrivate {
	gboolean _discoverable;
	gboolean _has_object;
	gboolean _retrieve_finished;
	gboolean _is_discovering;
	gboolean _is_powered;
	gboolean _is_connected;
	gboolean is_registered;
	GSettings* settings;
	GDBusObjectManagerClient* object_manager;
	BluetoothServicesAgentManager* agent_manager;
	BluetoothServicesAgent* agent;
};

struct _Block3Data {
	int _ref_count_;
	BluetoothServicesObjectManager* self;
	GDBusObject* object;
};

struct _Block4Data {
	int _ref_count_;
	BluetoothServicesObjectManager* self;
	GDBusObject* object;
};

struct _Block5Data {
	int _ref_count_;
	BluetoothServicesObjectManager* self;
	GDBusObject* object;
};

struct _BluetoothServicesObjectManagerCreateManagerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	GDBusObjectManagerClient* _tmp0_;
	GDBusObjectManagerClient* _tmp1_;
	GDBusObjectManagerClient* _tmp2_;
	GDBusObjectManagerClient* _tmp3_;
	GDBusObjectManagerClient* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GDBusObjectManagerClient* _tmp7_;
	GDBusObjectManagerClient* _tmp8_;
	GDBusObjectManagerClient* _tmp9_;
	GDBusObjectManagerClient* _tmp10_;
	GError* e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _Block6Data {
	int _ref_count_;
	BluetoothServicesObjectManager* self;
	GeeLinkedList* adapters;
};

struct _Block7Data {
	int _ref_count_;
	BluetoothServicesObjectManager* self;
	GeeLinkedList* devices;
};

struct _Block8Data {
	int _ref_count_;
	BluetoothServicesObjectManager* self;
	GtkWindow* window;
	gpointer _async_data_;
};

struct _BluetoothServicesObjectManagerCreateAgentData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	GtkWindow* window;
	Block8Data* _data8_;
	GDBusObjectManagerClient* _tmp0_;
	GDBusObject* bluez_object;
	GDBusObjectManagerClient* _tmp1_;
	GDBusObject* _tmp2_;
	GDBusObject* _tmp3_;
	GDBusObject* _tmp4_;
	GDBusInterface* _tmp5_;
	BluetoothServicesAgent* _tmp6_;
	BluetoothServicesAgent* _tmp7_;
	BluetoothServicesAgent* _tmp8_;
};

struct _BluetoothServicesObjectManagerRegisterAgentData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	GtkWindow* window;
	BluetoothServicesAgentManager* _tmp0_;
	gboolean _tmp1_;
	BluetoothServicesAgentManager* _tmp2_;
	BluetoothServicesAgent* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	BluetoothServicesAgentManager* _tmp6_;
	BluetoothServicesAgent* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	BluetoothServicesAgentManager* _tmp10_;
	BluetoothServicesAgent* _tmp11_;
	char* _tmp12_;
	char* _tmp13_;
	GError* e;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _BluetoothServicesObjectManagerUnregisterAgentData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	gboolean _tmp0_;
	BluetoothServicesAgentManager* _tmp1_;
	BluetoothServicesAgent* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	BluetoothServicesAgentManager* _tmp5_;
	BluetoothServicesAgent* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	GError* e;
	GError* _tmp9_;
	const gchar* _tmp10_;
	GError* _inner_error0_;
};

struct _BluetoothServicesObjectManagerStartDiscoveryData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	GeeLinkedList* adapters;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _adapter_list;
	GeeLinkedList* _tmp1_;
	gint _adapter_size;
	GeeLinkedList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _adapter_index;
	gint _tmp5_;
	gint _tmp6_;
	BluetoothServicesAdapter* adapter;
	GeeLinkedList* _tmp7_;
	gpointer _tmp8_;
	BluetoothServicesAdapter* _tmp9_;
	GError* e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_;
};

struct _BluetoothServicesObjectManagerStopDiscoveryData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	GeeLinkedList* adapters;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _adapter_list;
	GeeLinkedList* _tmp1_;
	gint _adapter_size;
	GeeLinkedList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _adapter_index;
	gint _tmp5_;
	gint _tmp6_;
	BluetoothServicesAdapter* adapter;
	GeeLinkedList* _tmp7_;
	gpointer _tmp8_;
	gboolean _tmp9_;
	BluetoothServicesAdapter* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	BluetoothServicesAdapter* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	BluetoothServicesAdapter* _tmp16_;
	GError* e;
	GError* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_;
};

struct _BluetoothServicesObjectManagerSetGlobalStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothServicesObjectManager* self;
	gboolean state;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeLinkedList* adapters;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* _adapter_list;
	GeeLinkedList* _tmp6_;
	gint _adapter_size;
	GeeLinkedList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _adapter_index;
	gint _tmp10_;
	gint _tmp11_;
	BluetoothServicesAdapter* adapter;
	GeeLinkedList* _tmp12_;
	gpointer _tmp13_;
	BluetoothServicesAdapter* _tmp14_;
	BluetoothServicesAdapter* _tmp15_;
	GSettings* _tmp16_;
	GSettings* _tmp17_;
	GeeCollection* devices;
	GeeCollection* _tmp18_;
	GeeIterator* _device_it;
	GeeCollection* _tmp19_;
	GeeIterator* _tmp20_;
	GeeIterator* _tmp21_;
	BluetoothServicesDevice* device;
	GeeIterator* _tmp22_;
	gpointer _tmp23_;
	BluetoothServicesDevice* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	BluetoothServicesDevice* _tmp27_;
	GError* e;
	GError* _tmp28_;
	const gchar* _tmp29_;
	GError* _inner_error0_;
};

static gint BluetoothServicesObjectManager_private_offset;
static gpointer bluetooth_services_object_manager_parent_class = NULL;

static GType bluetooth_services_agent_manager_get_type_once (void);
static void bluetooth_services_agent_manager_proxy_g_signal (GDBusProxy* proxy,
                                                      const gchar* sender_name,
                                                      const gchar* signal_name,
                                                      GVariant* parameters);
static void bluetooth_services_agent_manager_proxy_register_agent (BluetoothServicesAgentManager* self,
                                                            const char* agent,
                                                            const gchar* capability,
                                                            GError** error);
static void bluetooth_services_agent_manager_proxy_request_default_agent (BluetoothServicesAgentManager* self,
                                                                   const char* agent,
                                                                   GError** error);
static void bluetooth_services_agent_manager_proxy_unregister_agent (BluetoothServicesAgentManager* self,
                                                              const char* agent,
                                                              GError** error);
static void bluetooth_services_agent_manager_proxy_bluetooth_services_agent_manager_interface_init (BluetoothServicesAgentManagerIface* iface);
static void _dbus_bluetooth_services_agent_manager_register_agent (BluetoothServicesAgentManager* self,
                                                            GVariant* _parameters_,
                                                            GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_manager_request_default_agent (BluetoothServicesAgentManager* self,
                                                                   GVariant* _parameters_,
                                                                   GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_agent_manager_unregister_agent (BluetoothServicesAgentManager* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation);
static void bluetooth_services_agent_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                                  const gchar* sender,
                                                                  const gchar* object_path,
                                                                  const gchar* interface_name,
                                                                  const gchar* method_name,
                                                                  GVariant* parameters,
                                                                  GDBusMethodInvocation* invocation,
                                                                  gpointer user_data);
static GVariant* bluetooth_services_agent_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                                        const gchar* sender,
                                                                        const gchar* object_path,
                                                                        const gchar* interface_name,
                                                                        const gchar* property_name,
                                                                        GError** error,
                                                                        gpointer user_data);
static gboolean bluetooth_services_agent_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                                       const gchar* sender,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name,
                                                                       const gchar* property_name,
                                                                       GVariant* value,
                                                                       GError** error,
                                                                       gpointer user_data);
static void _bluetooth_services_agent_manager_unregister_object (gpointer user_data);
static void bluetooth_services_object_manager_create_manager_data_free (gpointer _data);
static void bluetooth_services_object_manager_create_manager (BluetoothServicesObjectManager* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void bluetooth_services_object_manager_create_manager_finish (BluetoothServicesObjectManager* self,
                                                              GAsyncResult* _res_);
static gboolean bluetooth_services_object_manager_create_manager_co (BluetoothServicesObjectManagerCreateManagerData* _data_);
static GType bluetooth_services_object_manager_object_manager_proxy_get_type (BluetoothServicesObjectManager* self,
                                                                       GDBusObjectManagerClient* manager,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name);
static GType _bluetooth_services_object_manager_object_manager_proxy_get_type_gd_bus_proxy_type_func (GDBusObjectManagerClient* manager,
                                                                                               const gchar* object_path,
                                                                                               const gchar* interface_name,
                                                                                               gpointer self);
static void bluetooth_services_object_manager_create_manager_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void ___lambda8_ (BluetoothServicesObjectManager* self,
                  GDBusObject* object);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda9_ (Block3Data* _data3_,
                 GDBusInterface* iface);
static void bluetooth_services_object_manager_on_interface_added (BluetoothServicesObjectManager* self,
                                                           GDBusObject* object,
                                                           GDBusInterface* iface);
static void ___lambda9__gfunc (gconstpointer data,
                        gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void ____lambda8__gfunc (gconstpointer data,
                         gpointer self);
static void _bluetooth_services_object_manager_on_interface_added_g_dbus_object_manager_interface_added (GDBusObjectManager* _sender,
                                                                                                  GDBusObject* object,
                                                                                                  GDBusInterface* interface_,
                                                                                                  gpointer self);
static void bluetooth_services_object_manager_on_interface_removed (BluetoothServicesObjectManager* self,
                                                             GDBusObject* object,
                                                             GDBusInterface* iface);
static void _bluetooth_services_object_manager_on_interface_removed_g_dbus_object_manager_interface_removed (GDBusObjectManager* _sender,
                                                                                                      GDBusObject* object,
                                                                                                      GDBusInterface* interface_,
                                                                                                      gpointer self);
static void ___lambda15_ (BluetoothServicesObjectManager* self,
                   GDBusObject* object);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda16_ (Block4Data* _data4_,
                  GDBusInterface* iface);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda15__g_dbus_object_manager_object_added (GDBusObjectManager* _sender,
                                                       GDBusObject* object,
                                                       gpointer self);
static void ___lambda17_ (BluetoothServicesObjectManager* self,
                   GDBusObject* object);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda18_ (Block5Data* _data5_,
                  GDBusInterface* iface);
static void ___lambda18__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda17__g_dbus_object_manager_object_removed (GDBusObjectManager* _sender,
                                                         GDBusObject* object,
                                                         gpointer self);
static void bluetooth_services_object_manager_set_retrieve_finished (BluetoothServicesObjectManager* self,
                                                              gboolean value);
GType bluetooth_services_device_proxy_get_type (void);
GType bluetooth_services_adapter_proxy_get_type (void);
static void ___lambda10_ (BluetoothServicesObjectManager* self,
                   GVariant* changed,
                   gchar** invalid);
static void ____lambda10__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                      GVariant* changed_properties,
                                                      gchar** invalidated_properties,
                                                      gpointer self);
static void bluetooth_services_object_manager_set_has_object (BluetoothServicesObjectManager* self,
                                                       gboolean value);
static void ____lambda14_ (BluetoothServicesObjectManager* self,
                    GVariant* changed,
                    gchar** invalid);
static void _____lambda14__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                       GVariant* changed_properties,
                                                       gchar** invalidated_properties,
                                                       gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda12_ (Block6Data* _data6_,
                   GDBusObject* object);
static void ____lambda12__gfunc (gconstpointer data,
                          gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda13_ (Block7Data* _data7_,
                   GDBusObject* object);
static void ____lambda13__gfunc (gconstpointer data,
                          gpointer self);
static void bluetooth_services_object_manager_create_agent_data_free (gpointer _data);
static void bluetooth_services_object_manager_create_agent (BluetoothServicesObjectManager* self,
                                                     GtkWindow* window,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void bluetooth_services_object_manager_create_agent_finish (BluetoothServicesObjectManager* self,
                                                            GAsyncResult* _res_);
static gboolean bluetooth_services_object_manager_create_agent_co (BluetoothServicesObjectManagerCreateAgentData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda19_ (Block8Data* _data8_);
static void ___lambda19__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda20_ (BluetoothServicesObjectManager* self);
static void ___lambda20__bluetooth_services_agent_unregistered (BluetoothServicesAgent* _sender,
                                                         gpointer self);
static void bluetooth_services_object_manager_register_agent_data_free (gpointer _data);
static gboolean bluetooth_services_object_manager_register_agent_co (BluetoothServicesObjectManagerRegisterAgentData* _data_);
static void bluetooth_services_object_manager_register_agent_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void bluetooth_services_object_manager_unregister_agent_data_free (gpointer _data);
static gboolean bluetooth_services_object_manager_unregister_agent_co (BluetoothServicesObjectManagerUnregisterAgentData* _data_);
static gboolean __lambda11_ (BluetoothServicesObjectManager* self);
static void bluetooth_services_object_manager_set_is_connected (BluetoothServicesObjectManager* self,
                                                         gboolean value);
static void bluetooth_services_object_manager_set_is_powered (BluetoothServicesObjectManager* self,
                                                       gboolean value);
static gboolean ___lambda11__gsource_func (gpointer self);
static void bluetooth_services_object_manager_start_discovery_data_free (gpointer _data);
static gboolean bluetooth_services_object_manager_start_discovery_co (BluetoothServicesObjectManagerStartDiscoveryData* _data_);
static void bluetooth_services_object_manager_set_is_discovering (BluetoothServicesObjectManager* self,
                                                           gboolean value);
static void bluetooth_services_object_manager_start_discovery_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
static void bluetooth_services_object_manager_stop_discovery_data_free (gpointer _data);
static gboolean bluetooth_services_object_manager_stop_discovery_co (BluetoothServicesObjectManagerStopDiscoveryData* _data_);
static void bluetooth_services_object_manager_stop_discovery_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void bluetooth_services_object_manager_set_global_state_data_free (gpointer _data);
static gboolean bluetooth_services_object_manager_set_global_state_co (BluetoothServicesObjectManagerSetGlobalStateData* _data_);
static void bluetooth_services_object_manager_set_global_state_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static GObject * bluetooth_services_object_manager_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void _bluetooth_services_object_manager___lambda21_ (BluetoothServicesObjectManager* self);
static gboolean __lambda22_ (BluetoothServicesObjectManager* self,
                      BluetoothServicesAdapter* adapter);
static gboolean ___lambda22__gee_forall_func (gpointer g,
                                       gpointer self);
static void __bluetooth_services_object_manager___lambda21__g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void bluetooth_services_object_manager_finalize (GObject * obj);
static GType bluetooth_services_object_manager_get_type_once (void);
static void _vala_bluetooth_services_object_manager_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_bluetooth_services_object_manager_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);

static const GDBusArgInfo _bluetooth_services_agent_manager_dbus_arg_info_register_agent_agent = {-1, "agent", "o", NULL};
static const GDBusArgInfo _bluetooth_services_agent_manager_dbus_arg_info_register_agent_capability = {-1, "capability", "s", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_manager_dbus_arg_info_register_agent_in[] = {&_bluetooth_services_agent_manager_dbus_arg_info_register_agent_agent, &_bluetooth_services_agent_manager_dbus_arg_info_register_agent_capability, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_manager_dbus_arg_info_register_agent_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_manager_dbus_method_info_register_agent = {-1, "RegisterAgent", (GDBusArgInfo **) (&_bluetooth_services_agent_manager_dbus_arg_info_register_agent_in), (GDBusArgInfo **) (&_bluetooth_services_agent_manager_dbus_arg_info_register_agent_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_manager_dbus_arg_info_request_default_agent_agent = {-1, "agent", "o", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_manager_dbus_arg_info_request_default_agent_in[] = {&_bluetooth_services_agent_manager_dbus_arg_info_request_default_agent_agent, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_manager_dbus_arg_info_request_default_agent_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_manager_dbus_method_info_request_default_agent = {-1, "RequestDefaultAgent", (GDBusArgInfo **) (&_bluetooth_services_agent_manager_dbus_arg_info_request_default_agent_in), (GDBusArgInfo **) (&_bluetooth_services_agent_manager_dbus_arg_info_request_default_agent_out), NULL};
static const GDBusArgInfo _bluetooth_services_agent_manager_dbus_arg_info_unregister_agent_agent = {-1, "agent", "o", NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_manager_dbus_arg_info_unregister_agent_in[] = {&_bluetooth_services_agent_manager_dbus_arg_info_unregister_agent_agent, NULL};
static const GDBusArgInfo * const _bluetooth_services_agent_manager_dbus_arg_info_unregister_agent_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_agent_manager_dbus_method_info_unregister_agent = {-1, "UnregisterAgent", (GDBusArgInfo **) (&_bluetooth_services_agent_manager_dbus_arg_info_unregister_agent_in), (GDBusArgInfo **) (&_bluetooth_services_agent_manager_dbus_arg_info_unregister_agent_out), NULL};
static const GDBusMethodInfo * const _bluetooth_services_agent_manager_dbus_method_info[] = {&_bluetooth_services_agent_manager_dbus_method_info_register_agent, &_bluetooth_services_agent_manager_dbus_method_info_request_default_agent, &_bluetooth_services_agent_manager_dbus_method_info_unregister_agent, NULL};
static const GDBusSignalInfo * const _bluetooth_services_agent_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _bluetooth_services_agent_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _bluetooth_services_agent_manager_dbus_interface_info = {-1, "org.bluez.AgentManager1", (GDBusMethodInfo **) (&_bluetooth_services_agent_manager_dbus_method_info), (GDBusSignalInfo **) (&_bluetooth_services_agent_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_bluetooth_services_agent_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _bluetooth_services_agent_manager_dbus_interface_vtable = {bluetooth_services_agent_manager_dbus_interface_method_call, bluetooth_services_agent_manager_dbus_interface_get_property, bluetooth_services_agent_manager_dbus_interface_set_property};

void
bluetooth_services_agent_manager_register_agent (BluetoothServicesAgentManager* self,
                                                 const char* agent,
                                                 const gchar* capability,
                                                 GError** error)
{
	BluetoothServicesAgentManagerIface* _iface_;
#line 23 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Services/Manager.vala"
	_iface_ = BLUETOOTH_SERVICES_AGENT_MANAGER_GET_INTERFACE (self);
#line 23 "../src/Services/Manager.vala"
	if (_iface_->register_agent) {
#line 23 "../src/Services/Manager.vala"
		_iface_->register_agent (self, agent, capability, error);
#line 589 "Manager.c"
	}
}

void
bluetooth_services_agent_manager_request_default_agent (BluetoothServicesAgentManager* self,
                                                        const char* agent,
                                                        GError** error)
{
	BluetoothServicesAgentManagerIface* _iface_;
#line 24 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Services/Manager.vala"
	_iface_ = BLUETOOTH_SERVICES_AGENT_MANAGER_GET_INTERFACE (self);
#line 24 "../src/Services/Manager.vala"
	if (_iface_->request_default_agent) {
#line 24 "../src/Services/Manager.vala"
		_iface_->request_default_agent (self, agent, error);
#line 607 "Manager.c"
	}
}

void
bluetooth_services_agent_manager_unregister_agent (BluetoothServicesAgentManager* self,
                                                   const char* agent,
                                                   GError** error)
{
	BluetoothServicesAgentManagerIface* _iface_;
#line 25 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Services/Manager.vala"
	_iface_ = BLUETOOTH_SERVICES_AGENT_MANAGER_GET_INTERFACE (self);
#line 25 "../src/Services/Manager.vala"
	if (_iface_->unregister_agent) {
#line 25 "../src/Services/Manager.vala"
		_iface_->unregister_agent (self, agent, error);
#line 625 "Manager.c"
	}
}

static void
bluetooth_services_agent_manager_default_init (BluetoothServicesAgentManagerIface * iface,
                                               gpointer iface_data)
{
}

static GType
bluetooth_services_agent_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothServicesAgentManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_services_agent_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType bluetooth_services_agent_manager_type_id;
	bluetooth_services_agent_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "BluetoothServicesAgentManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (bluetooth_services_agent_manager_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (bluetooth_services_agent_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) bluetooth_services_agent_manager_proxy_get_type);
	g_type_set_qdata (bluetooth_services_agent_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.bluez.AgentManager1");
	g_type_set_qdata (bluetooth_services_agent_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_bluetooth_services_agent_manager_dbus_interface_info));
	g_type_set_qdata (bluetooth_services_agent_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) bluetooth_services_agent_manager_register_object);
	return bluetooth_services_agent_manager_type_id;
}

GType
bluetooth_services_agent_manager_get_type (void)
{
	static volatile gsize bluetooth_services_agent_manager_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_services_agent_manager_type_id__once)) {
		GType bluetooth_services_agent_manager_type_id;
		bluetooth_services_agent_manager_type_id = bluetooth_services_agent_manager_get_type_once ();
		g_once_init_leave (&bluetooth_services_agent_manager_type_id__once, bluetooth_services_agent_manager_type_id);
	}
	return bluetooth_services_agent_manager_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (BluetoothServicesAgentManagerProxy, bluetooth_services_agent_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BLUETOOTH_SERVICES_TYPE_AGENT_MANAGER, bluetooth_services_agent_manager_proxy_bluetooth_services_agent_manager_interface_init) )
static void
bluetooth_services_agent_manager_proxy_class_init (BluetoothServicesAgentManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = bluetooth_services_agent_manager_proxy_g_signal;
}

static void
bluetooth_services_agent_manager_proxy_g_signal (GDBusProxy* proxy,
                                                 const gchar* sender_name,
                                                 const gchar* signal_name,
                                                 GVariant* parameters)
{
}

static void
bluetooth_services_agent_manager_proxy_init (BluetoothServicesAgentManagerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_bluetooth_services_agent_manager_dbus_interface_info));
}

static void
bluetooth_services_agent_manager_proxy_register_agent (BluetoothServicesAgentManager* self,
                                                       const char* agent,
                                                       const gchar* capability,
                                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.AgentManager1", "RegisterAgent");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (agent));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (capability));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
bluetooth_services_agent_manager_proxy_request_default_agent (BluetoothServicesAgentManager* self,
                                                              const char* agent,
                                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.AgentManager1", "RequestDefaultAgent");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (agent));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
bluetooth_services_agent_manager_proxy_unregister_agent (BluetoothServicesAgentManager* self,
                                                         const char* agent,
                                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.AgentManager1", "UnregisterAgent");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (agent));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
bluetooth_services_agent_manager_proxy_bluetooth_services_agent_manager_interface_init (BluetoothServicesAgentManagerIface* iface)
{
	iface->register_agent = bluetooth_services_agent_manager_proxy_register_agent;
	iface->request_default_agent = bluetooth_services_agent_manager_proxy_request_default_agent;
	iface->unregister_agent = bluetooth_services_agent_manager_proxy_unregister_agent;
}

static void
_dbus_bluetooth_services_agent_manager_register_agent (BluetoothServicesAgentManager* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* agent = NULL;
	GVariant* _tmp12_;
	gchar* capability = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	agent = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	capability = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	bluetooth_services_agent_manager_register_agent (self, agent, capability, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (agent);
	_g_free0 (capability);
	;
}

static void
_dbus_bluetooth_services_agent_manager_request_default_agent (BluetoothServicesAgentManager* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* agent = NULL;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	agent = g_variant_dup_string (_tmp14_, NULL);
	g_variant_unref (_tmp14_);
	bluetooth_services_agent_manager_request_default_agent (self, agent, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (agent);
	;
}

static void
_dbus_bluetooth_services_agent_manager_unregister_agent (BluetoothServicesAgentManager* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* agent = NULL;
	GVariant* _tmp15_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	agent = g_variant_dup_string (_tmp15_, NULL);
	g_variant_unref (_tmp15_);
	bluetooth_services_agent_manager_unregister_agent (self, agent, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (agent);
	;
}

static void
bluetooth_services_agent_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* method_name,
                                                             GVariant* parameters,
                                                             GDBusMethodInvocation* invocation,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "RegisterAgent") == 0) {
		_dbus_bluetooth_services_agent_manager_register_agent (object, parameters, invocation);
	} else if (strcmp (method_name, "RequestDefaultAgent") == 0) {
		_dbus_bluetooth_services_agent_manager_request_default_agent (object, parameters, invocation);
	} else if (strcmp (method_name, "UnregisterAgent") == 0) {
		_dbus_bluetooth_services_agent_manager_unregister_agent (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
bluetooth_services_agent_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                              const gchar* sender,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              const gchar* property_name,
                                                              GError** error,
                                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
bluetooth_services_agent_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                              const gchar* sender,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              const gchar* property_name,
                                                              GVariant* value,
                                                              GError** error,
                                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
bluetooth_services_agent_manager_register_object (gpointer object,
                                                  GDBusConnection* connection,
                                                  const gchar* path,
                                                  GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_bluetooth_services_agent_manager_dbus_interface_info), &_bluetooth_services_agent_manager_dbus_interface_vtable, data, _bluetooth_services_agent_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_bluetooth_services_agent_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
bluetooth_services_object_manager_get_instance_private (BluetoothServicesObjectManager* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothServicesObjectManager_private_offset);
}

static void
bluetooth_services_object_manager_create_manager_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerCreateManagerData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerCreateManagerData, _data_);
#line 978 "Manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/Services/Manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 986 "Manager.c"
}

static void
bluetooth_services_object_manager_create_manager (BluetoothServicesObjectManager* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	BluetoothServicesObjectManagerCreateManagerData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerCreateManagerData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_create_manager_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_create_manager_co (_data_);
#line 1010 "Manager.c"
}

static void
bluetooth_services_object_manager_create_manager_finish (BluetoothServicesObjectManager* self,
                                                         GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerCreateManagerData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1020 "Manager.c"
}

static GType
_bluetooth_services_object_manager_object_manager_proxy_get_type_gd_bus_proxy_type_func (GDBusObjectManagerClient* manager,
                                                                                         const gchar* object_path,
                                                                                         const gchar* interface_name,
                                                                                         gpointer self)
{
	GType result;
	result = bluetooth_services_object_manager_object_manager_proxy_get_type ((BluetoothServicesObjectManager*) self, manager, object_path, interface_name);
#line 64 "../src/Services/Manager.vala"
	return result;
#line 1033 "Manager.c"
}

static void
bluetooth_services_object_manager_create_manager_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	BluetoothServicesObjectManagerCreateManagerData* _data_;
#line 64 "../src/Services/Manager.vala"
	_data_ = _user_data_;
#line 64 "../src/Services/Manager.vala"
	_data_->_source_object_ = source_object;
#line 64 "../src/Services/Manager.vala"
	_data_->_res_ = _res_;
#line 64 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_create_manager_co (_data_);
#line 1050 "Manager.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 75 "../src/Services/Manager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 75 "../src/Services/Manager.vala"
	return _data3_;
#line 1060 "Manager.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 75 "../src/Services/Manager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1070 "Manager.c"
		BluetoothServicesObjectManager* self;
#line 75 "../src/Services/Manager.vala"
		self = _data3_->self;
#line 75 "../src/Services/Manager.vala"
		_g_object_unref0 (_data3_->object);
#line 75 "../src/Services/Manager.vala"
		_g_object_unref0 (self);
#line 75 "../src/Services/Manager.vala"
		g_slice_free (Block3Data, _data3_);
#line 1080 "Manager.c"
	}
}

static void
__lambda9_ (Block3Data* _data3_,
            GDBusInterface* iface)
{
	BluetoothServicesObjectManager* self;
#line 76 "../src/Services/Manager.vala"
	self = _data3_->self;
#line 76 "../src/Services/Manager.vala"
	g_return_if_fail (iface != NULL);
#line 76 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_on_interface_added (self, _data3_->object, iface);
#line 1095 "Manager.c"
}

static void
___lambda9__gfunc (gconstpointer data,
                   gpointer self)
{
#line 76 "../src/Services/Manager.vala"
	__lambda9_ (self, (GDBusInterface*) data);
#line 1104 "Manager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 76 "../src/Services/Manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1112 "Manager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 76 "../src/Services/Manager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1120 "Manager.c"
}

static void
___lambda8_ (BluetoothServicesObjectManager* self,
             GDBusObject* object)
{
	Block3Data* _data3_;
	GDBusObject* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 75 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 75 "../src/Services/Manager.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 75 "../src/Services/Manager.vala"
	_data3_->_ref_count_ = 1;
#line 75 "../src/Services/Manager.vala"
	_data3_->self = g_object_ref (self);
#line 75 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 75 "../src/Services/Manager.vala"
	_g_object_unref0 (_data3_->object);
#line 75 "../src/Services/Manager.vala"
	_data3_->object = _tmp0_;
#line 76 "../src/Services/Manager.vala"
	_tmp1_ = g_dbus_object_get_interfaces (_data3_->object);
#line 76 "../src/Services/Manager.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/Services/Manager.vala"
	g_list_foreach (_tmp2_, ___lambda9__gfunc, _data3_);
#line 76 "../src/Services/Manager.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 75 "../src/Services/Manager.vala"
	block3_data_unref (_data3_);
#line 75 "../src/Services/Manager.vala"
	_data3_ = NULL;
#line 1157 "Manager.c"
}

static void
____lambda8__gfunc (gconstpointer data,
                    gpointer self)
{
#line 75 "../src/Services/Manager.vala"
	___lambda8_ ((BluetoothServicesObjectManager*) self, (GDBusObject*) data);
#line 1166 "Manager.c"
}

static void
_bluetooth_services_object_manager_on_interface_added_g_dbus_object_manager_interface_added (GDBusObjectManager* _sender,
                                                                                             GDBusObject* object,
                                                                                             GDBusInterface* interface_,
                                                                                             gpointer self)
{
#line 78 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_on_interface_added ((BluetoothServicesObjectManager*) self, object, interface_);
#line 1177 "Manager.c"
}

static void
_bluetooth_services_object_manager_on_interface_removed_g_dbus_object_manager_interface_removed (GDBusObjectManager* _sender,
                                                                                                 GDBusObject* object,
                                                                                                 GDBusInterface* interface_,
                                                                                                 gpointer self)
{
#line 79 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_on_interface_removed ((BluetoothServicesObjectManager*) self, object, interface_);
#line 1188 "Manager.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 80 "../src/Services/Manager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 80 "../src/Services/Manager.vala"
	return _data4_;
#line 1198 "Manager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 80 "../src/Services/Manager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1208 "Manager.c"
		BluetoothServicesObjectManager* self;
#line 80 "../src/Services/Manager.vala"
		self = _data4_->self;
#line 80 "../src/Services/Manager.vala"
		_g_object_unref0 (_data4_->object);
#line 80 "../src/Services/Manager.vala"
		_g_object_unref0 (self);
#line 80 "../src/Services/Manager.vala"
		g_slice_free (Block4Data, _data4_);
#line 1218 "Manager.c"
	}
}

static void
__lambda16_ (Block4Data* _data4_,
             GDBusInterface* iface)
{
	BluetoothServicesObjectManager* self;
#line 81 "../src/Services/Manager.vala"
	self = _data4_->self;
#line 81 "../src/Services/Manager.vala"
	g_return_if_fail (iface != NULL);
#line 81 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_on_interface_added (self, _data4_->object, iface);
#line 1233 "Manager.c"
}

static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
#line 81 "../src/Services/Manager.vala"
	__lambda16_ (self, (GDBusInterface*) data);
#line 1242 "Manager.c"
}

static void
___lambda15_ (BluetoothServicesObjectManager* self,
              GDBusObject* object)
{
	Block4Data* _data4_;
	GDBusObject* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 80 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 80 "../src/Services/Manager.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 80 "../src/Services/Manager.vala"
	_data4_->_ref_count_ = 1;
#line 80 "../src/Services/Manager.vala"
	_data4_->self = g_object_ref (self);
#line 80 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 80 "../src/Services/Manager.vala"
	_g_object_unref0 (_data4_->object);
#line 80 "../src/Services/Manager.vala"
	_data4_->object = _tmp0_;
#line 81 "../src/Services/Manager.vala"
	_tmp1_ = g_dbus_object_get_interfaces (_data4_->object);
#line 81 "../src/Services/Manager.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/Services/Manager.vala"
	g_list_foreach (_tmp2_, ___lambda16__gfunc, _data4_);
#line 81 "../src/Services/Manager.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 80 "../src/Services/Manager.vala"
	block4_data_unref (_data4_);
#line 80 "../src/Services/Manager.vala"
	_data4_ = NULL;
#line 1279 "Manager.c"
}

static void
____lambda15__g_dbus_object_manager_object_added (GDBusObjectManager* _sender,
                                                  GDBusObject* object,
                                                  gpointer self)
{
#line 80 "../src/Services/Manager.vala"
	___lambda15_ ((BluetoothServicesObjectManager*) self, object);
#line 1289 "Manager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 83 "../src/Services/Manager.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 83 "../src/Services/Manager.vala"
	return _data5_;
#line 1299 "Manager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 83 "../src/Services/Manager.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1309 "Manager.c"
		BluetoothServicesObjectManager* self;
#line 83 "../src/Services/Manager.vala"
		self = _data5_->self;
#line 83 "../src/Services/Manager.vala"
		_g_object_unref0 (_data5_->object);
#line 83 "../src/Services/Manager.vala"
		_g_object_unref0 (self);
#line 83 "../src/Services/Manager.vala"
		g_slice_free (Block5Data, _data5_);
#line 1319 "Manager.c"
	}
}

static void
__lambda18_ (Block5Data* _data5_,
             GDBusInterface* iface)
{
	BluetoothServicesObjectManager* self;
#line 84 "../src/Services/Manager.vala"
	self = _data5_->self;
#line 84 "../src/Services/Manager.vala"
	g_return_if_fail (iface != NULL);
#line 84 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_on_interface_removed (self, _data5_->object, iface);
#line 1334 "Manager.c"
}

static void
___lambda18__gfunc (gconstpointer data,
                    gpointer self)
{
#line 84 "../src/Services/Manager.vala"
	__lambda18_ (self, (GDBusInterface*) data);
#line 1343 "Manager.c"
}

static void
___lambda17_ (BluetoothServicesObjectManager* self,
              GDBusObject* object)
{
	Block5Data* _data5_;
	GDBusObject* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 83 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 83 "../src/Services/Manager.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 83 "../src/Services/Manager.vala"
	_data5_->_ref_count_ = 1;
#line 83 "../src/Services/Manager.vala"
	_data5_->self = g_object_ref (self);
#line 83 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 83 "../src/Services/Manager.vala"
	_g_object_unref0 (_data5_->object);
#line 83 "../src/Services/Manager.vala"
	_data5_->object = _tmp0_;
#line 84 "../src/Services/Manager.vala"
	_tmp1_ = g_dbus_object_get_interfaces (_data5_->object);
#line 84 "../src/Services/Manager.vala"
	_tmp2_ = _tmp1_;
#line 84 "../src/Services/Manager.vala"
	g_list_foreach (_tmp2_, ___lambda18__gfunc, _data5_);
#line 84 "../src/Services/Manager.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 83 "../src/Services/Manager.vala"
	block5_data_unref (_data5_);
#line 83 "../src/Services/Manager.vala"
	_data5_ = NULL;
#line 1380 "Manager.c"
}

static void
____lambda17__g_dbus_object_manager_object_removed (GDBusObjectManager* _sender,
                                                    GDBusObject* object,
                                                    gpointer self)
{
#line 83 "../src/Services/Manager.vala"
	___lambda17_ ((BluetoothServicesObjectManager*) self, object);
#line 1390 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_create_manager_co (BluetoothServicesObjectManagerCreateManagerData* _data_)
{
#line 62 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 62 "../src/Services/Manager.vala"
		case 0:
#line 1400 "Manager.c"
		goto _state_0;
#line 62 "../src/Services/Manager.vala"
		case 1:
#line 1404 "Manager.c"
		goto _state_1;
		default:
#line 62 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 1409 "Manager.c"
	}
	_state_0:
	{
#line 64 "../src/Services/Manager.vala"
		_data_->_state_ = 1;
#line 64 "../src/Services/Manager.vala"
		g_dbus_object_manager_client_new_for_bus (G_BUS_TYPE_SYSTEM, G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_NONE, "org.bluez", "/", _bluetooth_services_object_manager_object_manager_proxy_get_type_gd_bus_proxy_type_func, g_object_ref (_data_->self), g_object_unref, NULL, bluetooth_services_object_manager_create_manager_ready, _data_);
#line 64 "../src/Services/Manager.vala"
		return FALSE;
#line 1419 "Manager.c"
		_state_1:
#line 64 "../src/Services/Manager.vala"
		_data_->_tmp1_ = g_dbus_object_manager_client_new_for_bus_finish (_data_->_res_, &_data_->_inner_error0_);
#line 64 "../src/Services/Manager.vala"
		_data_->_tmp0_ = _data_->_tmp1_;
#line 64 "../src/Services/Manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1427 "Manager.c"
			goto __catch0_g_error;
		}
#line 64 "../src/Services/Manager.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 64 "../src/Services/Manager.vala"
		_data_->_tmp0_ = NULL;
#line 64 "../src/Services/Manager.vala"
		_g_object_unref0 (_data_->self->priv->object_manager);
#line 64 "../src/Services/Manager.vala"
		_data_->self->priv->object_manager = _data_->_tmp2_;
#line 72 "../src/Services/Manager.vala"
		_data_->_tmp3_ = _data_->self->priv->object_manager;
#line 72 "../src/Services/Manager.vala"
		if (_data_->_tmp3_ == NULL) {
#line 73 "../src/Services/Manager.vala"
			_g_object_unref0 (_data_->_tmp0_);
#line 73 "../src/Services/Manager.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 73 "../src/Services/Manager.vala"
			if (_data_->_state_ != 0) {
#line 73 "../src/Services/Manager.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 73 "../src/Services/Manager.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1452 "Manager.c"
				}
			}
#line 73 "../src/Services/Manager.vala"
			g_object_unref (_data_->_async_result);
#line 73 "../src/Services/Manager.vala"
			return FALSE;
#line 1459 "Manager.c"
		}
#line 75 "../src/Services/Manager.vala"
		_data_->_tmp4_ = _data_->self->priv->object_manager;
#line 75 "../src/Services/Manager.vala"
		_data_->_tmp5_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _data_->_tmp4_);
#line 75 "../src/Services/Manager.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 75 "../src/Services/Manager.vala"
		g_list_foreach (_data_->_tmp6_, ____lambda8__gfunc, _data_->self);
#line 75 "../src/Services/Manager.vala"
		(_data_->_tmp6_ == NULL) ? NULL : (_data_->_tmp6_ = (_g_list_free__g_object_unref0_ (_data_->_tmp6_), NULL));
#line 78 "../src/Services/Manager.vala"
		_data_->_tmp7_ = _data_->self->priv->object_manager;
#line 78 "../src/Services/Manager.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp7_, "interface-added", (GCallback) _bluetooth_services_object_manager_on_interface_added_g_dbus_object_manager_interface_added, _data_->self, 0);
#line 79 "../src/Services/Manager.vala"
		_data_->_tmp8_ = _data_->self->priv->object_manager;
#line 79 "../src/Services/Manager.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp8_, "interface-removed", (GCallback) _bluetooth_services_object_manager_on_interface_removed_g_dbus_object_manager_interface_removed, _data_->self, 0);
#line 80 "../src/Services/Manager.vala"
		_data_->_tmp9_ = _data_->self->priv->object_manager;
#line 80 "../src/Services/Manager.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp9_, "object-added", (GCallback) ____lambda15__g_dbus_object_manager_object_added, _data_->self, 0);
#line 83 "../src/Services/Manager.vala"
		_data_->_tmp10_ = _data_->self->priv->object_manager;
#line 83 "../src/Services/Manager.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp10_, "object-removed", (GCallback) ____lambda17__g_dbus_object_manager_object_removed, _data_->self, 0);
#line 63 "../src/Services/Manager.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 1489 "Manager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 63 "../src/Services/Manager.vala"
		_data_->e = _data_->_inner_error0_;
#line 63 "../src/Services/Manager.vala"
		_data_->_inner_error0_ = NULL;
#line 87 "../src/Services/Manager.vala"
		_data_->_tmp11_ = _data_->e;
#line 87 "../src/Services/Manager.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 87 "../src/Services/Manager.vala"
		g_critical ("Manager.vala:87: %s", _data_->_tmp12_);
#line 63 "../src/Services/Manager.vala"
		_g_error_free0 (_data_->e);
#line 1506 "Manager.c"
	}
	__finally0:
#line 63 "../src/Services/Manager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/Services/Manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 63 "../src/Services/Manager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 63 "../src/Services/Manager.vala"
		g_object_unref (_data_->_async_result);
#line 63 "../src/Services/Manager.vala"
		return FALSE;
#line 1519 "Manager.c"
	}
#line 90 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_retrieve_finished (_data_->self, TRUE);
#line 62 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 62 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 62 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 62 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1531 "Manager.c"
		}
	}
#line 62 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 62 "../src/Services/Manager.vala"
	return FALSE;
#line 1538 "Manager.c"
}

static GType
bluetooth_services_object_manager_object_manager_proxy_get_type (BluetoothServicesObjectManager* self,
                                                                 GDBusObjectManagerClient* manager,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 107 "../src/Services/Manager.vala"
	static GQuark _tmp1_label0 = 0;
#line 107 "../src/Services/Manager.vala"
	static GQuark _tmp1_label1 = 0;
#line 107 "../src/Services/Manager.vala"
	static GQuark _tmp1_label2 = 0;
#line 1555 "Manager.c"
	GType result;
#line 103 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 103 "../src/Services/Manager.vala"
	g_return_val_if_fail (manager != NULL, 0UL);
#line 103 "../src/Services/Manager.vala"
	g_return_val_if_fail (object_path != NULL, 0UL);
#line 104 "../src/Services/Manager.vala"
	if (interface_name == NULL) {
#line 105 "../src/Services/Manager.vala"
		result = g_dbus_object_proxy_get_type ();
#line 105 "../src/Services/Manager.vala"
		return result;
#line 1569 "Manager.c"
	}
#line 107 "../src/Services/Manager.vala"
	_tmp0_ = interface_name;
#line 107 "../src/Services/Manager.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 107 "../src/Services/Manager.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("org.bluez.Device1")))) {
#line 107 "../src/Services/Manager.vala"
		switch (0) {
#line 1579 "Manager.c"
			default:
			{
#line 109 "../src/Services/Manager.vala"
				result = bluetooth_services_device_proxy_get_type ();
#line 109 "../src/Services/Manager.vala"
				return result;
#line 1586 "Manager.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("org.bluez.Adapter1")))) {
#line 107 "../src/Services/Manager.vala"
		switch (0) {
#line 1592 "Manager.c"
			default:
			{
#line 111 "../src/Services/Manager.vala"
				result = bluetooth_services_adapter_proxy_get_type ();
#line 111 "../src/Services/Manager.vala"
				return result;
#line 1599 "Manager.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("org.bluez.AgentManager1")))) {
#line 107 "../src/Services/Manager.vala"
		switch (0) {
#line 1605 "Manager.c"
			default:
			{
#line 113 "../src/Services/Manager.vala"
				result = bluetooth_services_agent_manager_proxy_get_type ();
#line 113 "../src/Services/Manager.vala"
				return result;
#line 1612 "Manager.c"
			}
		}
	} else {
#line 107 "../src/Services/Manager.vala"
		switch (0) {
#line 1618 "Manager.c"
			default:
			{
#line 115 "../src/Services/Manager.vala"
				result = g_dbus_proxy_get_type ();
#line 115 "../src/Services/Manager.vala"
				return result;
#line 1625 "Manager.c"
			}
		}
	}
}

static void
___lambda10_ (BluetoothServicesObjectManager* self,
              GVariant* changed,
              gchar** invalid)
{
	GVariant* connected = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* paired = NULL;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
#line 124 "../src/Services/Manager.vala"
	g_return_if_fail (changed != NULL);
#line 125 "../src/Services/Manager.vala"
	_tmp0_ = G_VARIANT_TYPE_BOOLEAN;
#line 125 "../src/Services/Manager.vala"
	_tmp1_ = g_variant_lookup_value (changed, "Connected", _tmp0_);
#line 125 "../src/Services/Manager.vala"
	connected = _tmp1_;
#line 126 "../src/Services/Manager.vala"
	_tmp2_ = connected;
#line 126 "../src/Services/Manager.vala"
	if (_tmp2_ != NULL) {
#line 127 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_check_global_state (self);
#line 1658 "Manager.c"
	}
#line 130 "../src/Services/Manager.vala"
	_tmp3_ = G_VARIANT_TYPE_BOOLEAN;
#line 130 "../src/Services/Manager.vala"
	_tmp4_ = g_variant_lookup_value (changed, "Paired", _tmp3_);
#line 130 "../src/Services/Manager.vala"
	paired = _tmp4_;
#line 131 "../src/Services/Manager.vala"
	_tmp5_ = paired;
#line 131 "../src/Services/Manager.vala"
	if (_tmp5_ != NULL) {
#line 132 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_check_global_state (self);
#line 1672 "Manager.c"
	}
#line 124 "../src/Services/Manager.vala"
	_g_variant_unref0 (paired);
#line 124 "../src/Services/Manager.vala"
	_g_variant_unref0 (connected);
#line 1678 "Manager.c"
}

static void
____lambda10__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                 GVariant* changed_properties,
                                                 gchar** invalidated_properties,
                                                 gpointer self)
{
#line 124 "../src/Services/Manager.vala"
	___lambda10_ ((BluetoothServicesObjectManager*) self, changed_properties, invalidated_properties);
#line 1689 "Manager.c"
}

static void
____lambda14_ (BluetoothServicesObjectManager* self,
               GVariant* changed,
               gchar** invalid)
{
	GVariant* powered = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* discovering = NULL;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* adapter_discoverable = NULL;
	const GVariantType* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
#line 142 "../src/Services/Manager.vala"
	g_return_if_fail (changed != NULL);
#line 143 "../src/Services/Manager.vala"
	_tmp0_ = G_VARIANT_TYPE_BOOLEAN;
#line 143 "../src/Services/Manager.vala"
	_tmp1_ = g_variant_lookup_value (changed, "Powered", _tmp0_);
#line 143 "../src/Services/Manager.vala"
	powered = _tmp1_;
#line 144 "../src/Services/Manager.vala"
	_tmp2_ = powered;
#line 144 "../src/Services/Manager.vala"
	if (_tmp2_ != NULL) {
#line 145 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_check_global_state (self);
#line 1723 "Manager.c"
	}
#line 148 "../src/Services/Manager.vala"
	_tmp3_ = G_VARIANT_TYPE_BOOLEAN;
#line 148 "../src/Services/Manager.vala"
	_tmp4_ = g_variant_lookup_value (changed, "Discovering", _tmp3_);
#line 148 "../src/Services/Manager.vala"
	discovering = _tmp4_;
#line 149 "../src/Services/Manager.vala"
	_tmp5_ = discovering;
#line 149 "../src/Services/Manager.vala"
	if (_tmp5_ != NULL) {
#line 150 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_check_discovering (self);
#line 1737 "Manager.c"
	}
#line 153 "../src/Services/Manager.vala"
	_tmp6_ = G_VARIANT_TYPE_BOOLEAN;
#line 153 "../src/Services/Manager.vala"
	_tmp7_ = g_variant_lookup_value (changed, "Discoverable", _tmp6_);
#line 153 "../src/Services/Manager.vala"
	adapter_discoverable = _tmp7_;
#line 154 "../src/Services/Manager.vala"
	_tmp8_ = adapter_discoverable;
#line 154 "../src/Services/Manager.vala"
	if (_tmp8_ != NULL) {
#line 155 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_check_discoverable (self);
#line 1751 "Manager.c"
	}
#line 142 "../src/Services/Manager.vala"
	_g_variant_unref0 (adapter_discoverable);
#line 142 "../src/Services/Manager.vala"
	_g_variant_unref0 (discovering);
#line 142 "../src/Services/Manager.vala"
	_g_variant_unref0 (powered);
#line 1759 "Manager.c"
}

static void
_____lambda14__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                  GVariant* changed_properties,
                                                  gchar** invalidated_properties,
                                                  gpointer self)
{
#line 142 "../src/Services/Manager.vala"
	____lambda14_ ((BluetoothServicesObjectManager*) self, changed_properties, invalidated_properties);
#line 1770 "Manager.c"
}

static void
bluetooth_services_object_manager_on_interface_added (BluetoothServicesObjectManager* self,
                                                      GDBusObject* object,
                                                      GDBusInterface* iface)
{
#line 119 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 119 "../src/Services/Manager.vala"
	g_return_if_fail (iface != NULL);
#line 120 "../src/Services/Manager.vala"
	if (BLUETOOTH_SERVICES_IS_DEVICE (iface)) {
#line 1786 "Manager.c"
		BluetoothServicesDevice* device = NULL;
		BluetoothServicesDevice* _tmp0_;
		BluetoothServicesDevice* _tmp1_;
#line 121 "../src/Services/Manager.vala"
		device = G_TYPE_CHECK_INSTANCE_CAST (iface, BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice);
#line 123 "../src/Services/Manager.vala"
		_tmp0_ = device;
#line 123 "../src/Services/Manager.vala"
		g_signal_emit (self, bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_DEVICE_ADDED_SIGNAL], 0, _tmp0_);
#line 124 "../src/Services/Manager.vala"
		_tmp1_ = device;
#line 124 "../src/Services/Manager.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) ____lambda10__g_dbus_proxy_g_properties_changed, self, 0);
#line 136 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_check_global_state (self);
#line 1802 "Manager.c"
	} else {
#line 137 "../src/Services/Manager.vala"
		if (BLUETOOTH_SERVICES_IS_ADAPTER (iface)) {
#line 1806 "Manager.c"
			BluetoothServicesAdapter* adapter = NULL;
			BluetoothServicesAdapter* _tmp2_;
			BluetoothServicesAdapter* _tmp3_;
#line 138 "../src/Services/Manager.vala"
			adapter = G_TYPE_CHECK_INSTANCE_CAST (iface, BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter);
#line 139 "../src/Services/Manager.vala"
			bluetooth_services_object_manager_set_has_object (self, TRUE);
#line 141 "../src/Services/Manager.vala"
			_tmp2_ = adapter;
#line 141 "../src/Services/Manager.vala"
			g_signal_emit (self, bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_ADAPTER_ADDED_SIGNAL], 0, _tmp2_);
#line 142 "../src/Services/Manager.vala"
			_tmp3_ = adapter;
#line 142 "../src/Services/Manager.vala"
			g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) _____lambda14__g_dbus_proxy_g_properties_changed, self, 0);
#line 159 "../src/Services/Manager.vala"
			bluetooth_services_object_manager_check_global_state (self);
#line 1824 "Manager.c"
		}
	}
}

static void
bluetooth_services_object_manager_on_interface_removed (BluetoothServicesObjectManager* self,
                                                        GDBusObject* object,
                                                        GDBusInterface* iface)
{
#line 163 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 163 "../src/Services/Manager.vala"
	g_return_if_fail (iface != NULL);
#line 164 "../src/Services/Manager.vala"
	if (BLUETOOTH_SERVICES_IS_DEVICE (iface)) {
#line 165 "../src/Services/Manager.vala"
		g_signal_emit (self, bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_DEVICE_REMOVED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (iface, BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice));
#line 1844 "Manager.c"
	} else {
#line 166 "../src/Services/Manager.vala"
		if (BLUETOOTH_SERVICES_IS_ADAPTER (iface)) {
#line 1848 "Manager.c"
			GeeLinkedList* _tmp0_;
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 167 "../src/Services/Manager.vala"
			g_signal_emit (self, bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_ADAPTER_REMOVED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (iface, BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter));
#line 168 "../src/Services/Manager.vala"
			_tmp0_ = bluetooth_services_object_manager_get_adapters (self);
#line 168 "../src/Services/Manager.vala"
			_tmp1_ = _tmp0_;
#line 168 "../src/Services/Manager.vala"
			_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 168 "../src/Services/Manager.vala"
			_tmp3_ = _tmp2_;
#line 168 "../src/Services/Manager.vala"
			bluetooth_services_object_manager_set_has_object (self, !_tmp3_);
#line 168 "../src/Services/Manager.vala"
			_g_object_unref0 (_tmp1_);
#line 1867 "Manager.c"
		}
	}
}

void
bluetooth_services_object_manager_check_discovering (BluetoothServicesObjectManager* self)
{
	GeeLinkedList* adapters = NULL;
	GeeLinkedList* _tmp0_;
#line 172 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/Services/Manager.vala"
	_tmp0_ = bluetooth_services_object_manager_get_adapters (self);
#line 173 "../src/Services/Manager.vala"
	adapters = _tmp0_;
#line 1883 "Manager.c"
	{
		GeeLinkedList* _adapter_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _adapter_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _adapter_index = 0;
#line 174 "../src/Services/Manager.vala"
		_tmp1_ = adapters;
#line 174 "../src/Services/Manager.vala"
		_adapter_list = _tmp1_;
#line 174 "../src/Services/Manager.vala"
		_tmp2_ = _adapter_list;
#line 174 "../src/Services/Manager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 174 "../src/Services/Manager.vala"
		_tmp4_ = _tmp3_;
#line 174 "../src/Services/Manager.vala"
		_adapter_size = _tmp4_;
#line 174 "../src/Services/Manager.vala"
		_adapter_index = -1;
#line 174 "../src/Services/Manager.vala"
		while (TRUE) {
#line 1908 "Manager.c"
			gint _tmp5_;
			gint _tmp6_;
			BluetoothServicesAdapter* adapter = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			BluetoothServicesAdapter* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 174 "../src/Services/Manager.vala"
			_adapter_index = _adapter_index + 1;
#line 174 "../src/Services/Manager.vala"
			_tmp5_ = _adapter_index;
#line 174 "../src/Services/Manager.vala"
			_tmp6_ = _adapter_size;
#line 174 "../src/Services/Manager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 174 "../src/Services/Manager.vala"
				break;
#line 1928 "Manager.c"
			}
#line 174 "../src/Services/Manager.vala"
			_tmp7_ = _adapter_list;
#line 174 "../src/Services/Manager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _adapter_index);
#line 174 "../src/Services/Manager.vala"
			adapter = (BluetoothServicesAdapter*) _tmp8_;
#line 175 "../src/Services/Manager.vala"
			_tmp9_ = adapter;
#line 175 "../src/Services/Manager.vala"
			_tmp10_ = bluetooth_services_adapter_get_discovering (_tmp9_);
#line 175 "../src/Services/Manager.vala"
			_tmp11_ = _tmp10_;
#line 175 "../src/Services/Manager.vala"
			_tmp12_ = self->priv->_is_discovering;
#line 175 "../src/Services/Manager.vala"
			if (_tmp11_ != _tmp12_) {
#line 1946 "Manager.c"
				gboolean _tmp13_;
#line 176 "../src/Services/Manager.vala"
				_tmp13_ = self->priv->_is_discovering;
#line 176 "../src/Services/Manager.vala"
				if (_tmp13_) {
#line 1952 "Manager.c"
					BluetoothServicesAdapter* _tmp14_;
#line 177 "../src/Services/Manager.vala"
					_tmp14_ = adapter;
#line 177 "../src/Services/Manager.vala"
					bluetooth_services_adapter_start_discovery (_tmp14_, NULL, NULL);
#line 1958 "Manager.c"
				} else {
					BluetoothServicesAdapter* _tmp15_;
#line 179 "../src/Services/Manager.vala"
					_tmp15_ = adapter;
#line 179 "../src/Services/Manager.vala"
					bluetooth_services_adapter_stop_discovery (_tmp15_, NULL, NULL);
#line 1965 "Manager.c"
				}
			}
#line 174 "../src/Services/Manager.vala"
			_g_object_unref0 (adapter);
#line 1970 "Manager.c"
		}
	}
#line 172 "../src/Services/Manager.vala"
	_g_object_unref0 (adapters);
#line 1975 "Manager.c"
}

void
bluetooth_services_object_manager_check_discoverable (BluetoothServicesObjectManager* self)
{
	GeeLinkedList* adapters = NULL;
	GeeLinkedList* _tmp0_;
#line 185 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/Services/Manager.vala"
	_tmp0_ = bluetooth_services_object_manager_get_adapters (self);
#line 186 "../src/Services/Manager.vala"
	adapters = _tmp0_;
#line 1989 "Manager.c"
	{
		GeeLinkedList* _adapter_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _adapter_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _adapter_index = 0;
#line 187 "../src/Services/Manager.vala"
		_tmp1_ = adapters;
#line 187 "../src/Services/Manager.vala"
		_adapter_list = _tmp1_;
#line 187 "../src/Services/Manager.vala"
		_tmp2_ = _adapter_list;
#line 187 "../src/Services/Manager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 187 "../src/Services/Manager.vala"
		_tmp4_ = _tmp3_;
#line 187 "../src/Services/Manager.vala"
		_adapter_size = _tmp4_;
#line 187 "../src/Services/Manager.vala"
		_adapter_index = -1;
#line 187 "../src/Services/Manager.vala"
		while (TRUE) {
#line 2014 "Manager.c"
			gint _tmp5_;
			gint _tmp6_;
			BluetoothServicesAdapter* adapter = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			BluetoothServicesAdapter* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 187 "../src/Services/Manager.vala"
			_adapter_index = _adapter_index + 1;
#line 187 "../src/Services/Manager.vala"
			_tmp5_ = _adapter_index;
#line 187 "../src/Services/Manager.vala"
			_tmp6_ = _adapter_size;
#line 187 "../src/Services/Manager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 187 "../src/Services/Manager.vala"
				break;
#line 2034 "Manager.c"
			}
#line 187 "../src/Services/Manager.vala"
			_tmp7_ = _adapter_list;
#line 187 "../src/Services/Manager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _adapter_index);
#line 187 "../src/Services/Manager.vala"
			adapter = (BluetoothServicesAdapter*) _tmp8_;
#line 188 "../src/Services/Manager.vala"
			_tmp9_ = adapter;
#line 188 "../src/Services/Manager.vala"
			_tmp10_ = bluetooth_services_adapter_get_discoverable (_tmp9_);
#line 188 "../src/Services/Manager.vala"
			_tmp11_ = _tmp10_;
#line 188 "../src/Services/Manager.vala"
			_tmp12_ = self->priv->_discoverable;
#line 188 "../src/Services/Manager.vala"
			if (_tmp11_ != _tmp12_) {
#line 2052 "Manager.c"
				BluetoothServicesAdapter* _tmp13_;
				gboolean _tmp14_;
#line 189 "../src/Services/Manager.vala"
				_tmp13_ = adapter;
#line 189 "../src/Services/Manager.vala"
				_tmp14_ = self->priv->_discoverable;
#line 189 "../src/Services/Manager.vala"
				bluetooth_services_adapter_set_discoverable (_tmp13_, _tmp14_);
#line 2061 "Manager.c"
			}
#line 187 "../src/Services/Manager.vala"
			_g_object_unref0 (adapter);
#line 2065 "Manager.c"
		}
	}
#line 185 "../src/Services/Manager.vala"
	_g_object_unref0 (adapters);
#line 2070 "Manager.c"
}

gchar*
bluetooth_services_object_manager_get_name (BluetoothServicesObjectManager* self)
{
	GeeLinkedList* adapters = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* result;
#line 194 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 195 "../src/Services/Manager.vala"
	_tmp0_ = bluetooth_services_object_manager_get_adapters (self);
#line 195 "../src/Services/Manager.vala"
	adapters = _tmp0_;
#line 196 "../src/Services/Manager.vala"
	_tmp1_ = adapters;
#line 196 "../src/Services/Manager.vala"
	_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 196 "../src/Services/Manager.vala"
	_tmp3_ = _tmp2_;
#line 196 "../src/Services/Manager.vala"
	if (_tmp3_) {
#line 197 "../src/Services/Manager.vala"
		result = NULL;
#line 197 "../src/Services/Manager.vala"
		_g_object_unref0 (adapters);
#line 197 "../src/Services/Manager.vala"
		return result;
#line 2102 "Manager.c"
	} else {
		GeeLinkedList* _tmp4_;
		gpointer _tmp5_;
		BluetoothServicesAdapter* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 199 "../src/Services/Manager.vala"
		_tmp4_ = adapters;
#line 199 "../src/Services/Manager.vala"
		_tmp5_ = gee_linked_list_first (_tmp4_);
#line 199 "../src/Services/Manager.vala"
		_tmp6_ = (BluetoothServicesAdapter*) _tmp5_;
#line 199 "../src/Services/Manager.vala"
		_tmp7_ = bluetooth_services_adapter_get_name (_tmp6_);
#line 199 "../src/Services/Manager.vala"
		_tmp8_ = _tmp7_;
#line 199 "../src/Services/Manager.vala"
		_tmp9_ = _tmp8_;
#line 199 "../src/Services/Manager.vala"
		_g_object_unref0 (_tmp6_);
#line 199 "../src/Services/Manager.vala"
		result = _tmp9_;
#line 199 "../src/Services/Manager.vala"
		_g_object_unref0 (adapters);
#line 199 "../src/Services/Manager.vala"
		return result;
#line 2130 "Manager.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 203 "../src/Services/Manager.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 203 "../src/Services/Manager.vala"
	return _data6_;
#line 2141 "Manager.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 203 "../src/Services/Manager.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2151 "Manager.c"
		BluetoothServicesObjectManager* self;
#line 203 "../src/Services/Manager.vala"
		self = _data6_->self;
#line 203 "../src/Services/Manager.vala"
		_g_object_unref0 (_data6_->adapters);
#line 203 "../src/Services/Manager.vala"
		_g_object_unref0 (self);
#line 203 "../src/Services/Manager.vala"
		g_slice_free (Block6Data, _data6_);
#line 2161 "Manager.c"
	}
}

static void
___lambda12_ (Block6Data* _data6_,
              GDBusObject* object)
{
	BluetoothServicesObjectManager* self;
	GDBusInterface* iface = NULL;
	GDBusInterface* _tmp0_;
	GDBusInterface* _tmp1_;
	GeeLinkedList* _tmp2_;
	GDBusInterface* _tmp3_;
#line 206 "../src/Services/Manager.vala"
	self = _data6_->self;
#line 206 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 207 "../src/Services/Manager.vala"
	_tmp0_ = g_dbus_object_get_interface (object, "org.bluez.Adapter1");
#line 207 "../src/Services/Manager.vala"
	iface = _tmp0_;
#line 208 "../src/Services/Manager.vala"
	_tmp1_ = iface;
#line 208 "../src/Services/Manager.vala"
	if (_tmp1_ == NULL) {
#line 209 "../src/Services/Manager.vala"
		_g_object_unref0 (iface);
#line 209 "../src/Services/Manager.vala"
		return;
#line 2191 "Manager.c"
	}
#line 211 "../src/Services/Manager.vala"
	_tmp2_ = _data6_->adapters;
#line 211 "../src/Services/Manager.vala"
	_tmp3_ = iface;
#line 211 "../src/Services/Manager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter));
#line 206 "../src/Services/Manager.vala"
	_g_object_unref0 (iface);
#line 2201 "Manager.c"
}

static void
____lambda12__gfunc (gconstpointer data,
                     gpointer self)
{
#line 206 "../src/Services/Manager.vala"
	___lambda12_ (self, (GDBusObject*) data);
#line 2210 "Manager.c"
}

GeeLinkedList*
bluetooth_services_object_manager_get_adapters (BluetoothServicesObjectManager* self)
{
	Block6Data* _data6_;
	GeeLinkedList* _tmp0_;
	GDBusObjectManagerClient* _tmp1_;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* result;
#line 203 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../src/Services/Manager.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 203 "../src/Services/Manager.vala"
	_data6_->_ref_count_ = 1;
#line 203 "../src/Services/Manager.vala"
	_data6_->self = g_object_ref (self);
#line 204 "../src/Services/Manager.vala"
	_tmp0_ = gee_linked_list_new (BLUETOOTH_SERVICES_TYPE_ADAPTER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 204 "../src/Services/Manager.vala"
	_data6_->adapters = _tmp0_;
#line 205 "../src/Services/Manager.vala"
	_tmp1_ = self->priv->object_manager;
#line 205 "../src/Services/Manager.vala"
	if (_tmp1_ != NULL) {
#line 2237 "Manager.c"
		GDBusObjectManagerClient* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
#line 206 "../src/Services/Manager.vala"
		_tmp2_ = self->priv->object_manager;
#line 206 "../src/Services/Manager.vala"
		_tmp3_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _tmp2_);
#line 206 "../src/Services/Manager.vala"
		_tmp4_ = _tmp3_;
#line 206 "../src/Services/Manager.vala"
		g_list_foreach (_tmp4_, ____lambda12__gfunc, _data6_);
#line 206 "../src/Services/Manager.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 2251 "Manager.c"
	}
#line 215 "../src/Services/Manager.vala"
	_tmp5_ = _data6_->adapters;
#line 215 "../src/Services/Manager.vala"
	_data6_->adapters = NULL;
#line 215 "../src/Services/Manager.vala"
	result = _tmp5_;
#line 215 "../src/Services/Manager.vala"
	block6_data_unref (_data6_);
#line 215 "../src/Services/Manager.vala"
	_data6_ = NULL;
#line 215 "../src/Services/Manager.vala"
	return result;
#line 2265 "Manager.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 218 "../src/Services/Manager.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 218 "../src/Services/Manager.vala"
	return _data7_;
#line 2275 "Manager.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 218 "../src/Services/Manager.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2285 "Manager.c"
		BluetoothServicesObjectManager* self;
#line 218 "../src/Services/Manager.vala"
		self = _data7_->self;
#line 218 "../src/Services/Manager.vala"
		_g_object_unref0 (_data7_->devices);
#line 218 "../src/Services/Manager.vala"
		_g_object_unref0 (self);
#line 218 "../src/Services/Manager.vala"
		g_slice_free (Block7Data, _data7_);
#line 2295 "Manager.c"
	}
}

static void
___lambda13_ (Block7Data* _data7_,
              GDBusObject* object)
{
	BluetoothServicesObjectManager* self;
	GDBusInterface* iface = NULL;
	GDBusInterface* _tmp0_;
	GDBusInterface* _tmp1_;
	GeeLinkedList* _tmp2_;
	GDBusInterface* _tmp3_;
#line 221 "../src/Services/Manager.vala"
	self = _data7_->self;
#line 221 "../src/Services/Manager.vala"
	g_return_if_fail (object != NULL);
#line 222 "../src/Services/Manager.vala"
	_tmp0_ = g_dbus_object_get_interface (object, "org.bluez.Device1");
#line 222 "../src/Services/Manager.vala"
	iface = _tmp0_;
#line 223 "../src/Services/Manager.vala"
	_tmp1_ = iface;
#line 223 "../src/Services/Manager.vala"
	if (_tmp1_ == NULL) {
#line 224 "../src/Services/Manager.vala"
		_g_object_unref0 (iface);
#line 224 "../src/Services/Manager.vala"
		return;
#line 2325 "Manager.c"
	}
#line 226 "../src/Services/Manager.vala"
	_tmp2_ = _data7_->devices;
#line 226 "../src/Services/Manager.vala"
	_tmp3_ = iface;
#line 226 "../src/Services/Manager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice));
#line 221 "../src/Services/Manager.vala"
	_g_object_unref0 (iface);
#line 2335 "Manager.c"
}

static void
____lambda13__gfunc (gconstpointer data,
                     gpointer self)
{
#line 221 "../src/Services/Manager.vala"
	___lambda13_ (self, (GDBusObject*) data);
#line 2344 "Manager.c"
}

GeeCollection*
bluetooth_services_object_manager_get_devices (BluetoothServicesObjectManager* self)
{
	Block7Data* _data7_;
	GeeLinkedList* _tmp0_;
	GDBusObjectManagerClient* _tmp1_;
	GeeLinkedList* _tmp5_;
	GeeCollection* result;
#line 218 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../src/Services/Manager.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 218 "../src/Services/Manager.vala"
	_data7_->_ref_count_ = 1;
#line 218 "../src/Services/Manager.vala"
	_data7_->self = g_object_ref (self);
#line 219 "../src/Services/Manager.vala"
	_tmp0_ = gee_linked_list_new (BLUETOOTH_SERVICES_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 219 "../src/Services/Manager.vala"
	_data7_->devices = _tmp0_;
#line 220 "../src/Services/Manager.vala"
	_tmp1_ = self->priv->object_manager;
#line 220 "../src/Services/Manager.vala"
	if (_tmp1_ != NULL) {
#line 2371 "Manager.c"
		GDBusObjectManagerClient* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
#line 221 "../src/Services/Manager.vala"
		_tmp2_ = self->priv->object_manager;
#line 221 "../src/Services/Manager.vala"
		_tmp3_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _tmp2_);
#line 221 "../src/Services/Manager.vala"
		_tmp4_ = _tmp3_;
#line 221 "../src/Services/Manager.vala"
		g_list_foreach (_tmp4_, ____lambda13__gfunc, _data7_);
#line 221 "../src/Services/Manager.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 2385 "Manager.c"
	}
#line 230 "../src/Services/Manager.vala"
	_tmp5_ = _data7_->devices;
#line 230 "../src/Services/Manager.vala"
	_data7_->devices = NULL;
#line 230 "../src/Services/Manager.vala"
	result = (GeeCollection*) _tmp5_;
#line 230 "../src/Services/Manager.vala"
	block7_data_unref (_data7_);
#line 230 "../src/Services/Manager.vala"
	_data7_ = NULL;
#line 230 "../src/Services/Manager.vala"
	return result;
#line 2399 "Manager.c"
}

BluetoothServicesAdapter*
bluetooth_services_object_manager_get_adapter_from_path (BluetoothServicesObjectManager* self,
                                                         const gchar* path)
{
	GDBusObject* object = NULL;
	GDBusObjectManagerClient* _tmp0_;
	GDBusObject* _tmp1_;
	GDBusObject* _tmp2_;
	BluetoothServicesAdapter* result;
#line 233 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/Services/Manager.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 234 "../src/Services/Manager.vala"
	_tmp0_ = self->priv->object_manager;
#line 234 "../src/Services/Manager.vala"
	_tmp1_ = g_dbus_object_manager_get_object ((GDBusObjectManager*) _tmp0_, path);
#line 234 "../src/Services/Manager.vala"
	object = _tmp1_;
#line 235 "../src/Services/Manager.vala"
	_tmp2_ = object;
#line 235 "../src/Services/Manager.vala"
	if (_tmp2_ != NULL) {
#line 2425 "Manager.c"
		GDBusObject* _tmp3_;
		GDBusInterface* _tmp4_;
#line 236 "../src/Services/Manager.vala"
		_tmp3_ = object;
#line 236 "../src/Services/Manager.vala"
		_tmp4_ = g_dbus_object_get_interface (_tmp3_, "org.bluez.Adapter1");
#line 236 "../src/Services/Manager.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter);
#line 236 "../src/Services/Manager.vala"
		_g_object_unref0 (object);
#line 236 "../src/Services/Manager.vala"
		return result;
#line 2438 "Manager.c"
	}
#line 239 "../src/Services/Manager.vala"
	result = NULL;
#line 239 "../src/Services/Manager.vala"
	_g_object_unref0 (object);
#line 239 "../src/Services/Manager.vala"
	return result;
#line 2446 "Manager.c"
}

static void
bluetooth_services_object_manager_create_agent_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerCreateAgentData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerCreateAgentData, _data_);
#line 2458 "Manager.c"
}

static void
bluetooth_services_object_manager_create_agent (BluetoothServicesObjectManager* self,
                                                GtkWindow* window,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	BluetoothServicesObjectManagerCreateAgentData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
	GtkWindow* _tmp1_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerCreateAgentData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_create_agent_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	_tmp1_ = _g_object_ref0 (window);
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->window);
#line 28 "../src/Services/Manager.vala"
	_data_->window = _tmp1_;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_create_agent_co (_data_);
#line 2490 "Manager.c"
}

static void
bluetooth_services_object_manager_create_agent_finish (BluetoothServicesObjectManager* self,
                                                       GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerCreateAgentData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2500 "Manager.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 242 "../src/Services/Manager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 242 "../src/Services/Manager.vala"
	return _data8_;
#line 2510 "Manager.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 242 "../src/Services/Manager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 2520 "Manager.c"
		BluetoothServicesObjectManager* self;
#line 242 "../src/Services/Manager.vala"
		self = _data8_->self;
#line 242 "../src/Services/Manager.vala"
		_g_object_unref0 (_data8_->window);
#line 242 "../src/Services/Manager.vala"
		_g_object_unref0 (self);
#line 242 "../src/Services/Manager.vala"
		g_slice_free (Block8Data, _data8_);
#line 2530 "Manager.c"
	}
}

static void
__lambda19_ (Block8Data* _data8_)
{
	BluetoothServicesObjectManager* self;
#line 252 "../src/Services/Manager.vala"
	self = _data8_->self;
#line 253 "../src/Services/Manager.vala"
	if (self->priv->is_registered) {
#line 254 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_register_agent (self, _data8_->window, NULL, NULL);
#line 2544 "Manager.c"
	}
}

static void
___lambda19__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 252 "../src/Services/Manager.vala"
	__lambda19_ (self);
#line 2555 "Manager.c"
}

static void
__lambda20_ (BluetoothServicesObjectManager* self)
{
#line 259 "../src/Services/Manager.vala"
	self->priv->is_registered = FALSE;
#line 2563 "Manager.c"
}

static void
___lambda20__bluetooth_services_agent_unregistered (BluetoothServicesAgent* _sender,
                                                    gpointer self)
{
#line 258 "../src/Services/Manager.vala"
	__lambda20_ ((BluetoothServicesObjectManager*) self);
#line 2572 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_create_agent_co (BluetoothServicesObjectManagerCreateAgentData* _data_)
{
#line 242 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 242 "../src/Services/Manager.vala"
		case 0:
#line 2582 "Manager.c"
		goto _state_0;
		default:
#line 242 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 2587 "Manager.c"
	}
	_state_0:
#line 242 "../src/Services/Manager.vala"
	_data_->_data8_ = g_slice_new0 (Block8Data);
#line 242 "../src/Services/Manager.vala"
	_data_->_data8_->_ref_count_ = 1;
#line 242 "../src/Services/Manager.vala"
	_data_->_data8_->self = g_object_ref (_data_->self);
#line 242 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->_data8_->window);
#line 242 "../src/Services/Manager.vala"
	_data_->_data8_->window = _data_->window;
#line 242 "../src/Services/Manager.vala"
	_data_->_data8_->_async_data_ = _data_;
#line 243 "../src/Services/Manager.vala"
	_data_->_tmp0_ = _data_->self->priv->object_manager;
#line 243 "../src/Services/Manager.vala"
	if (_data_->_tmp0_ == NULL) {
#line 244 "../src/Services/Manager.vala"
		block8_data_unref (_data_->_data8_);
#line 244 "../src/Services/Manager.vala"
		_data_->_data8_ = NULL;
#line 244 "../src/Services/Manager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 244 "../src/Services/Manager.vala"
		if (_data_->_state_ != 0) {
#line 244 "../src/Services/Manager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 244 "../src/Services/Manager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2618 "Manager.c"
			}
		}
#line 244 "../src/Services/Manager.vala"
		g_object_unref (_data_->_async_result);
#line 244 "../src/Services/Manager.vala"
		return FALSE;
#line 2625 "Manager.c"
	}
#line 246 "../src/Services/Manager.vala"
	_data_->_tmp1_ = _data_->self->priv->object_manager;
#line 246 "../src/Services/Manager.vala"
	_data_->_tmp2_ = g_dbus_object_manager_get_object ((GDBusObjectManager*) _data_->_tmp1_, "/org/bluez");
#line 246 "../src/Services/Manager.vala"
	_data_->bluez_object = _data_->_tmp2_;
#line 247 "../src/Services/Manager.vala"
	_data_->_tmp3_ = _data_->bluez_object;
#line 247 "../src/Services/Manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 248 "../src/Services/Manager.vala"
		_data_->_tmp4_ = _data_->bluez_object;
#line 248 "../src/Services/Manager.vala"
		_data_->_tmp5_ = g_dbus_object_get_interface (_data_->_tmp4_, "org.bluez.AgentManager1");
#line 248 "../src/Services/Manager.vala"
		_g_object_unref0 (_data_->self->priv->agent_manager);
#line 248 "../src/Services/Manager.vala"
		_data_->self->priv->agent_manager = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, BLUETOOTH_SERVICES_TYPE_AGENT_MANAGER, BluetoothServicesAgentManager);
#line 2645 "Manager.c"
	}
#line 251 "../src/Services/Manager.vala"
	_data_->_tmp6_ = bluetooth_services_agent_new (_data_->_data8_->window);
#line 251 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self->priv->agent);
#line 251 "../src/Services/Manager.vala"
	_data_->self->priv->agent = _data_->_tmp6_;
#line 252 "../src/Services/Manager.vala"
	_data_->_tmp7_ = _data_->self->priv->agent;
#line 252 "../src/Services/Manager.vala"
	g_signal_connect_data ((GObject*) _data_->_tmp7_, "notify::ready", (GCallback) ___lambda19__g_object_notify, block8_data_ref (_data_->_data8_), (GClosureNotify) block8_data_unref, 0);
#line 258 "../src/Services/Manager.vala"
	_data_->_tmp8_ = _data_->self->priv->agent;
#line 258 "../src/Services/Manager.vala"
	g_signal_connect_object (_data_->_tmp8_, "unregistered", (GCallback) ___lambda20__bluetooth_services_agent_unregistered, _data_->self, 0);
#line 242 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->bluez_object);
#line 242 "../src/Services/Manager.vala"
	block8_data_unref (_data_->_data8_);
#line 242 "../src/Services/Manager.vala"
	_data_->_data8_ = NULL;
#line 242 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 242 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 242 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 242 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2675 "Manager.c"
		}
	}
#line 242 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 242 "../src/Services/Manager.vala"
	return FALSE;
#line 2682 "Manager.c"
}

static void
bluetooth_services_object_manager_register_agent_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerRegisterAgentData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->window);
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerRegisterAgentData, _data_);
#line 2696 "Manager.c"
}

void
bluetooth_services_object_manager_register_agent (BluetoothServicesObjectManager* self,
                                                  GtkWindow* window,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	BluetoothServicesObjectManagerRegisterAgentData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
	GtkWindow* _tmp1_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerRegisterAgentData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_register_agent_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	_tmp1_ = _g_object_ref0 (window);
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->window);
#line 28 "../src/Services/Manager.vala"
	_data_->window = _tmp1_;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_register_agent_co (_data_);
#line 2728 "Manager.c"
}

void
bluetooth_services_object_manager_register_agent_finish (BluetoothServicesObjectManager* self,
                                                         GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerRegisterAgentData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2738 "Manager.c"
}

static void
bluetooth_services_object_manager_register_agent_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	BluetoothServicesObjectManagerRegisterAgentData* _data_;
#line 266 "../src/Services/Manager.vala"
	_data_ = _user_data_;
#line 266 "../src/Services/Manager.vala"
	_data_->_source_object_ = source_object;
#line 266 "../src/Services/Manager.vala"
	_data_->_res_ = _res_;
#line 266 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_register_agent_co (_data_);
#line 2755 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_register_agent_co (BluetoothServicesObjectManagerRegisterAgentData* _data_)
{
#line 263 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 263 "../src/Services/Manager.vala"
		case 0:
#line 2765 "Manager.c"
		goto _state_0;
#line 263 "../src/Services/Manager.vala"
		case 1:
#line 2769 "Manager.c"
		goto _state_1;
		default:
#line 263 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 2774 "Manager.c"
	}
	_state_0:
#line 264 "../src/Services/Manager.vala"
	_data_->self->priv->is_registered = TRUE;
#line 265 "../src/Services/Manager.vala"
	_data_->_tmp0_ = _data_->self->priv->agent_manager;
#line 265 "../src/Services/Manager.vala"
	if (_data_->_tmp0_ == NULL) {
#line 266 "../src/Services/Manager.vala"
		_data_->_state_ = 1;
#line 266 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_create_agent (_data_->self, _data_->window, bluetooth_services_object_manager_register_agent_ready, _data_);
#line 266 "../src/Services/Manager.vala"
		return FALSE;
#line 2789 "Manager.c"
		_state_1:
#line 266 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_create_agent_finish (_data_->self, _data_->_res_);
#line 2793 "Manager.c"
	}
#line 269 "../src/Services/Manager.vala"
	_data_->_tmp2_ = _data_->self->priv->agent_manager;
#line 269 "../src/Services/Manager.vala"
	if (_data_->_tmp2_ != NULL) {
#line 269 "../src/Services/Manager.vala"
		_data_->_tmp3_ = _data_->self->priv->agent;
#line 269 "../src/Services/Manager.vala"
		_data_->_tmp4_ = bluetooth_services_agent_get_ready (_data_->_tmp3_);
#line 269 "../src/Services/Manager.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 269 "../src/Services/Manager.vala"
		_data_->_tmp1_ = _data_->_tmp5_;
#line 2807 "Manager.c"
	} else {
#line 269 "../src/Services/Manager.vala"
		_data_->_tmp1_ = FALSE;
#line 2811 "Manager.c"
	}
#line 269 "../src/Services/Manager.vala"
	if (_data_->_tmp1_) {
#line 2815 "Manager.c"
		{
#line 271 "../src/Services/Manager.vala"
			_data_->_tmp6_ = _data_->self->priv->agent_manager;
#line 271 "../src/Services/Manager.vala"
			_data_->_tmp7_ = _data_->self->priv->agent;
#line 271 "../src/Services/Manager.vala"
			_data_->_tmp8_ = bluetooth_services_agent_get_path (_data_->_tmp7_);
#line 271 "../src/Services/Manager.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 271 "../src/Services/Manager.vala"
			bluetooth_services_agent_manager_register_agent (_data_->_tmp6_, _data_->_tmp9_, "DisplayYesNo", &_data_->_inner_error0_);
#line 271 "../src/Services/Manager.vala"
			_g_free0 (_data_->_tmp9_);
#line 271 "../src/Services/Manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2831 "Manager.c"
				goto __catch0_g_error;
			}
#line 272 "../src/Services/Manager.vala"
			_data_->_tmp10_ = _data_->self->priv->agent_manager;
#line 272 "../src/Services/Manager.vala"
			_data_->_tmp11_ = _data_->self->priv->agent;
#line 272 "../src/Services/Manager.vala"
			_data_->_tmp12_ = bluetooth_services_agent_get_path (_data_->_tmp11_);
#line 272 "../src/Services/Manager.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 272 "../src/Services/Manager.vala"
			bluetooth_services_agent_manager_request_default_agent (_data_->_tmp10_, _data_->_tmp13_, &_data_->_inner_error0_);
#line 272 "../src/Services/Manager.vala"
			_g_free0 (_data_->_tmp13_);
#line 272 "../src/Services/Manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2848 "Manager.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 270 "../src/Services/Manager.vala"
			_data_->e = _data_->_inner_error0_;
#line 270 "../src/Services/Manager.vala"
			_data_->_inner_error0_ = NULL;
#line 274 "../src/Services/Manager.vala"
			_data_->_tmp14_ = _data_->e;
#line 274 "../src/Services/Manager.vala"
			_data_->_tmp15_ = _data_->_tmp14_->message;
#line 274 "../src/Services/Manager.vala"
			g_critical ("Manager.vala:274: %s", _data_->_tmp15_);
#line 270 "../src/Services/Manager.vala"
			_g_error_free0 (_data_->e);
#line 2867 "Manager.c"
		}
		__finally0:
#line 270 "../src/Services/Manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 270 "../src/Services/Manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 270 "../src/Services/Manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 270 "../src/Services/Manager.vala"
			g_object_unref (_data_->_async_result);
#line 270 "../src/Services/Manager.vala"
			return FALSE;
#line 2880 "Manager.c"
		}
	}
#line 263 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 263 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 263 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 263 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2891 "Manager.c"
		}
	}
#line 263 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 263 "../src/Services/Manager.vala"
	return FALSE;
#line 2898 "Manager.c"
}

static void
bluetooth_services_object_manager_unregister_agent_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerUnregisterAgentData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerUnregisterAgentData, _data_);
#line 2910 "Manager.c"
}

void
bluetooth_services_object_manager_unregister_agent (BluetoothServicesObjectManager* self,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	BluetoothServicesObjectManagerUnregisterAgentData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerUnregisterAgentData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_unregister_agent_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_unregister_agent_co (_data_);
#line 2934 "Manager.c"
}

void
bluetooth_services_object_manager_unregister_agent_finish (BluetoothServicesObjectManager* self,
                                                           GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerUnregisterAgentData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2944 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_unregister_agent_co (BluetoothServicesObjectManagerUnregisterAgentData* _data_)
{
#line 279 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 279 "../src/Services/Manager.vala"
		case 0:
#line 2954 "Manager.c"
		goto _state_0;
		default:
#line 279 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 2959 "Manager.c"
	}
	_state_0:
#line 280 "../src/Services/Manager.vala"
	_data_->self->priv->is_registered = FALSE;
#line 281 "../src/Services/Manager.vala"
	_data_->_tmp1_ = _data_->self->priv->agent_manager;
#line 281 "../src/Services/Manager.vala"
	if (_data_->_tmp1_ != NULL) {
#line 281 "../src/Services/Manager.vala"
		_data_->_tmp2_ = _data_->self->priv->agent;
#line 281 "../src/Services/Manager.vala"
		_data_->_tmp3_ = bluetooth_services_agent_get_ready (_data_->_tmp2_);
#line 281 "../src/Services/Manager.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 281 "../src/Services/Manager.vala"
		_data_->_tmp0_ = _data_->_tmp4_;
#line 2976 "Manager.c"
	} else {
#line 281 "../src/Services/Manager.vala"
		_data_->_tmp0_ = FALSE;
#line 2980 "Manager.c"
	}
#line 281 "../src/Services/Manager.vala"
	if (_data_->_tmp0_) {
#line 2984 "Manager.c"
		{
#line 283 "../src/Services/Manager.vala"
			_data_->_tmp5_ = _data_->self->priv->agent_manager;
#line 283 "../src/Services/Manager.vala"
			_data_->_tmp6_ = _data_->self->priv->agent;
#line 283 "../src/Services/Manager.vala"
			_data_->_tmp7_ = bluetooth_services_agent_get_path (_data_->_tmp6_);
#line 283 "../src/Services/Manager.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 283 "../src/Services/Manager.vala"
			bluetooth_services_agent_manager_unregister_agent (_data_->_tmp5_, _data_->_tmp8_, &_data_->_inner_error0_);
#line 283 "../src/Services/Manager.vala"
			_g_free0 (_data_->_tmp8_);
#line 283 "../src/Services/Manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3000 "Manager.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 282 "../src/Services/Manager.vala"
			_data_->e = _data_->_inner_error0_;
#line 282 "../src/Services/Manager.vala"
			_data_->_inner_error0_ = NULL;
#line 285 "../src/Services/Manager.vala"
			_data_->_tmp9_ = _data_->e;
#line 285 "../src/Services/Manager.vala"
			_data_->_tmp10_ = _data_->_tmp9_->message;
#line 285 "../src/Services/Manager.vala"
			g_critical ("Manager.vala:285: %s", _data_->_tmp10_);
#line 282 "../src/Services/Manager.vala"
			_g_error_free0 (_data_->e);
#line 3019 "Manager.c"
		}
		__finally0:
#line 282 "../src/Services/Manager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 282 "../src/Services/Manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 282 "../src/Services/Manager.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 282 "../src/Services/Manager.vala"
			g_object_unref (_data_->_async_result);
#line 282 "../src/Services/Manager.vala"
			return FALSE;
#line 3032 "Manager.c"
		}
	}
#line 279 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 279 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 279 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 279 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3043 "Manager.c"
		}
	}
#line 279 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 279 "../src/Services/Manager.vala"
	return FALSE;
#line 3050 "Manager.c"
}

static gboolean
__lambda11_ (BluetoothServicesObjectManager* self)
{
	gboolean powered = FALSE;
	gboolean connected = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean result;
#line 294 "../src/Services/Manager.vala"
	powered = bluetooth_services_object_manager_get_global_state (self);
#line 295 "../src/Services/Manager.vala"
	connected = bluetooth_services_object_manager_get_connected (self);
#line 298 "../src/Services/Manager.vala"
	_tmp1_ = self->priv->_is_powered;
#line 298 "../src/Services/Manager.vala"
	if (powered != _tmp1_) {
#line 298 "../src/Services/Manager.vala"
		_tmp0_ = TRUE;
#line 3071 "Manager.c"
	} else {
		gboolean _tmp2_;
#line 298 "../src/Services/Manager.vala"
		_tmp2_ = self->priv->_is_connected;
#line 298 "../src/Services/Manager.vala"
		_tmp0_ = connected != _tmp2_;
#line 3078 "Manager.c"
	}
#line 298 "../src/Services/Manager.vala"
	if (_tmp0_) {
#line 299 "../src/Services/Manager.vala"
		if (!powered) {
#line 300 "../src/Services/Manager.vala"
			bluetooth_services_object_manager_set_discoverable (self, FALSE);
#line 3086 "Manager.c"
		}
#line 303 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_is_connected (self, connected);
#line 304 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_is_powered (self, powered);
#line 3092 "Manager.c"
	}
#line 307 "../src/Services/Manager.vala"
	result = FALSE;
#line 307 "../src/Services/Manager.vala"
	return result;
#line 3098 "Manager.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((BluetoothServicesObjectManager*) self);
#line 293 "../src/Services/Manager.vala"
	return result;
#line 3108 "Manager.c"
}

void
bluetooth_services_object_manager_check_global_state (BluetoothServicesObjectManager* self)
{
#line 290 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/Services/Manager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 3118 "Manager.c"
}

static void
bluetooth_services_object_manager_start_discovery_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerStartDiscoveryData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerStartDiscoveryData, _data_);
#line 3130 "Manager.c"
}

void
bluetooth_services_object_manager_start_discovery (BluetoothServicesObjectManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	BluetoothServicesObjectManagerStartDiscoveryData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerStartDiscoveryData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_start_discovery_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_start_discovery_co (_data_);
#line 3154 "Manager.c"
}

void
bluetooth_services_object_manager_start_discovery_finish (BluetoothServicesObjectManager* self,
                                                          GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerStartDiscoveryData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3164 "Manager.c"
}

static void
bluetooth_services_object_manager_start_discovery_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	BluetoothServicesObjectManagerStartDiscoveryData* _data_;
#line 316 "../src/Services/Manager.vala"
	_data_ = _user_data_;
#line 316 "../src/Services/Manager.vala"
	_data_->_source_object_ = source_object;
#line 316 "../src/Services/Manager.vala"
	_data_->_res_ = _res_;
#line 316 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_start_discovery_co (_data_);
#line 3181 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_start_discovery_co (BluetoothServicesObjectManagerStartDiscoveryData* _data_)
{
#line 311 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 311 "../src/Services/Manager.vala"
		case 0:
#line 3191 "Manager.c"
		goto _state_0;
#line 311 "../src/Services/Manager.vala"
		case 1:
#line 3195 "Manager.c"
		goto _state_1;
		default:
#line 311 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 3200 "Manager.c"
	}
	_state_0:
#line 312 "../src/Services/Manager.vala"
	_data_->_tmp0_ = bluetooth_services_object_manager_get_adapters (_data_->self);
#line 312 "../src/Services/Manager.vala"
	_data_->adapters = _data_->_tmp0_;
#line 313 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_is_discovering (_data_->self, TRUE);
#line 3209 "Manager.c"
	{
#line 314 "../src/Services/Manager.vala"
		_data_->_tmp1_ = _data_->adapters;
#line 314 "../src/Services/Manager.vala"
		_data_->_adapter_list = _data_->_tmp1_;
#line 314 "../src/Services/Manager.vala"
		_data_->_tmp2_ = _data_->_adapter_list;
#line 314 "../src/Services/Manager.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 314 "../src/Services/Manager.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 314 "../src/Services/Manager.vala"
		_data_->_adapter_size = _data_->_tmp4_;
#line 314 "../src/Services/Manager.vala"
		_data_->_adapter_index = -1;
#line 314 "../src/Services/Manager.vala"
		while (TRUE) {
#line 314 "../src/Services/Manager.vala"
			_data_->_adapter_index = _data_->_adapter_index + 1;
#line 314 "../src/Services/Manager.vala"
			_data_->_tmp5_ = _data_->_adapter_index;
#line 314 "../src/Services/Manager.vala"
			_data_->_tmp6_ = _data_->_adapter_size;
#line 314 "../src/Services/Manager.vala"
			if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 314 "../src/Services/Manager.vala"
				break;
#line 3237 "Manager.c"
			}
#line 314 "../src/Services/Manager.vala"
			_data_->_tmp7_ = _data_->_adapter_list;
#line 314 "../src/Services/Manager.vala"
			_data_->_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp7_, _data_->_adapter_index);
#line 314 "../src/Services/Manager.vala"
			_data_->adapter = (BluetoothServicesAdapter*) _data_->_tmp8_;
#line 3245 "Manager.c"
			{
#line 316 "../src/Services/Manager.vala"
				_data_->_tmp9_ = _data_->adapter;
#line 316 "../src/Services/Manager.vala"
				_data_->_state_ = 1;
#line 316 "../src/Services/Manager.vala"
				bluetooth_services_adapter_start_discovery (_data_->_tmp9_, bluetooth_services_object_manager_start_discovery_ready, _data_);
#line 316 "../src/Services/Manager.vala"
				return FALSE;
#line 3255 "Manager.c"
				_state_1:
#line 316 "../src/Services/Manager.vala"
				bluetooth_services_adapter_start_discovery_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 316 "../src/Services/Manager.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3261 "Manager.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 315 "../src/Services/Manager.vala"
				_data_->e = _data_->_inner_error0_;
#line 315 "../src/Services/Manager.vala"
				_data_->_inner_error0_ = NULL;
#line 318 "../src/Services/Manager.vala"
				_data_->_tmp10_ = _data_->e;
#line 318 "../src/Services/Manager.vala"
				_data_->_tmp11_ = _data_->_tmp10_->message;
#line 318 "../src/Services/Manager.vala"
				g_critical ("Manager.vala:318: %s", _data_->_tmp11_);
#line 315 "../src/Services/Manager.vala"
				_g_error_free0 (_data_->e);
#line 3280 "Manager.c"
			}
			__finally0:
#line 315 "../src/Services/Manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 315 "../src/Services/Manager.vala"
				_g_object_unref0 (_data_->adapter);
#line 315 "../src/Services/Manager.vala"
				_g_object_unref0 (_data_->adapters);
#line 315 "../src/Services/Manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 315 "../src/Services/Manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 315 "../src/Services/Manager.vala"
				g_object_unref (_data_->_async_result);
#line 315 "../src/Services/Manager.vala"
				return FALSE;
#line 3297 "Manager.c"
			}
#line 314 "../src/Services/Manager.vala"
			_g_object_unref0 (_data_->adapter);
#line 3301 "Manager.c"
		}
	}
#line 311 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->adapters);
#line 311 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 311 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 311 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 311 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3314 "Manager.c"
		}
	}
#line 311 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 311 "../src/Services/Manager.vala"
	return FALSE;
#line 3321 "Manager.c"
}

static void
bluetooth_services_object_manager_stop_discovery_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerStopDiscoveryData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerStopDiscoveryData, _data_);
#line 3333 "Manager.c"
}

void
bluetooth_services_object_manager_stop_discovery (BluetoothServicesObjectManager* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	BluetoothServicesObjectManagerStopDiscoveryData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerStopDiscoveryData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_stop_discovery_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_stop_discovery_co (_data_);
#line 3357 "Manager.c"
}

void
bluetooth_services_object_manager_stop_discovery_finish (BluetoothServicesObjectManager* self,
                                                         GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerStopDiscoveryData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3367 "Manager.c"
}

static void
bluetooth_services_object_manager_stop_discovery_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	BluetoothServicesObjectManagerStopDiscoveryData* _data_;
#line 329 "../src/Services/Manager.vala"
	_data_ = _user_data_;
#line 329 "../src/Services/Manager.vala"
	_data_->_source_object_ = source_object;
#line 329 "../src/Services/Manager.vala"
	_data_->_res_ = _res_;
#line 329 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_stop_discovery_co (_data_);
#line 3384 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_stop_discovery_co (BluetoothServicesObjectManagerStopDiscoveryData* _data_)
{
#line 323 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 323 "../src/Services/Manager.vala"
		case 0:
#line 3394 "Manager.c"
		goto _state_0;
#line 323 "../src/Services/Manager.vala"
		case 1:
#line 3398 "Manager.c"
		goto _state_1;
		default:
#line 323 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 3403 "Manager.c"
	}
	_state_0:
#line 324 "../src/Services/Manager.vala"
	_data_->_tmp0_ = bluetooth_services_object_manager_get_adapters (_data_->self);
#line 324 "../src/Services/Manager.vala"
	_data_->adapters = _data_->_tmp0_;
#line 325 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_is_discovering (_data_->self, FALSE);
#line 3412 "Manager.c"
	{
#line 326 "../src/Services/Manager.vala"
		_data_->_tmp1_ = _data_->adapters;
#line 326 "../src/Services/Manager.vala"
		_data_->_adapter_list = _data_->_tmp1_;
#line 326 "../src/Services/Manager.vala"
		_data_->_tmp2_ = _data_->_adapter_list;
#line 326 "../src/Services/Manager.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 326 "../src/Services/Manager.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 326 "../src/Services/Manager.vala"
		_data_->_adapter_size = _data_->_tmp4_;
#line 326 "../src/Services/Manager.vala"
		_data_->_adapter_index = -1;
#line 326 "../src/Services/Manager.vala"
		while (TRUE) {
#line 326 "../src/Services/Manager.vala"
			_data_->_adapter_index = _data_->_adapter_index + 1;
#line 326 "../src/Services/Manager.vala"
			_data_->_tmp5_ = _data_->_adapter_index;
#line 326 "../src/Services/Manager.vala"
			_data_->_tmp6_ = _data_->_adapter_size;
#line 326 "../src/Services/Manager.vala"
			if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 326 "../src/Services/Manager.vala"
				break;
#line 3440 "Manager.c"
			}
#line 326 "../src/Services/Manager.vala"
			_data_->_tmp7_ = _data_->_adapter_list;
#line 326 "../src/Services/Manager.vala"
			_data_->_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp7_, _data_->_adapter_index);
#line 326 "../src/Services/Manager.vala"
			_data_->adapter = (BluetoothServicesAdapter*) _data_->_tmp8_;
#line 3448 "Manager.c"
			{
#line 328 "../src/Services/Manager.vala"
				_data_->_tmp10_ = _data_->adapter;
#line 328 "../src/Services/Manager.vala"
				_data_->_tmp11_ = bluetooth_services_adapter_get_powered (_data_->_tmp10_);
#line 328 "../src/Services/Manager.vala"
				_data_->_tmp12_ = _data_->_tmp11_;
#line 328 "../src/Services/Manager.vala"
				if (_data_->_tmp12_) {
#line 328 "../src/Services/Manager.vala"
					_data_->_tmp13_ = _data_->adapter;
#line 328 "../src/Services/Manager.vala"
					_data_->_tmp14_ = bluetooth_services_adapter_get_discovering (_data_->_tmp13_);
#line 328 "../src/Services/Manager.vala"
					_data_->_tmp15_ = _data_->_tmp14_;
#line 328 "../src/Services/Manager.vala"
					_data_->_tmp9_ = _data_->_tmp15_;
#line 3466 "Manager.c"
				} else {
#line 328 "../src/Services/Manager.vala"
					_data_->_tmp9_ = FALSE;
#line 3470 "Manager.c"
				}
#line 328 "../src/Services/Manager.vala"
				if (_data_->_tmp9_) {
#line 329 "../src/Services/Manager.vala"
					_data_->_tmp16_ = _data_->adapter;
#line 329 "../src/Services/Manager.vala"
					_data_->_state_ = 1;
#line 329 "../src/Services/Manager.vala"
					bluetooth_services_adapter_stop_discovery (_data_->_tmp16_, bluetooth_services_object_manager_stop_discovery_ready, _data_);
#line 329 "../src/Services/Manager.vala"
					return FALSE;
#line 3482 "Manager.c"
					_state_1:
#line 329 "../src/Services/Manager.vala"
					bluetooth_services_adapter_stop_discovery_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 329 "../src/Services/Manager.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3488 "Manager.c"
						goto __catch0_g_error;
					}
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 327 "../src/Services/Manager.vala"
				_data_->e = _data_->_inner_error0_;
#line 327 "../src/Services/Manager.vala"
				_data_->_inner_error0_ = NULL;
#line 332 "../src/Services/Manager.vala"
				_data_->_tmp17_ = _data_->e;
#line 332 "../src/Services/Manager.vala"
				_data_->_tmp18_ = _data_->_tmp17_->message;
#line 332 "../src/Services/Manager.vala"
				g_critical ("Manager.vala:332: %s", _data_->_tmp18_);
#line 327 "../src/Services/Manager.vala"
				_g_error_free0 (_data_->e);
#line 3508 "Manager.c"
			}
			__finally0:
#line 327 "../src/Services/Manager.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 327 "../src/Services/Manager.vala"
				_g_object_unref0 (_data_->adapter);
#line 327 "../src/Services/Manager.vala"
				_g_object_unref0 (_data_->adapters);
#line 327 "../src/Services/Manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 327 "../src/Services/Manager.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 327 "../src/Services/Manager.vala"
				g_object_unref (_data_->_async_result);
#line 327 "../src/Services/Manager.vala"
				return FALSE;
#line 3525 "Manager.c"
			}
#line 326 "../src/Services/Manager.vala"
			_g_object_unref0 (_data_->adapter);
#line 3529 "Manager.c"
		}
	}
#line 323 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->adapters);
#line 323 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 323 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 323 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 323 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3542 "Manager.c"
		}
	}
#line 323 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 323 "../src/Services/Manager.vala"
	return FALSE;
#line 3549 "Manager.c"
}

gboolean
bluetooth_services_object_manager_get_connected (BluetoothServicesObjectManager* self)
{
	GeeCollection* devices = NULL;
	GeeCollection* _tmp0_;
	gboolean result;
#line 337 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 338 "../src/Services/Manager.vala"
	_tmp0_ = bluetooth_services_object_manager_get_devices (self);
#line 338 "../src/Services/Manager.vala"
	devices = _tmp0_;
#line 3564 "Manager.c"
	{
		GeeIterator* _device_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
#line 339 "../src/Services/Manager.vala"
		_tmp1_ = devices;
#line 339 "../src/Services/Manager.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 339 "../src/Services/Manager.vala"
		_device_it = _tmp2_;
#line 339 "../src/Services/Manager.vala"
		while (TRUE) {
#line 3577 "Manager.c"
			GeeIterator* _tmp3_;
			BluetoothServicesDevice* device = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			BluetoothServicesDevice* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 339 "../src/Services/Manager.vala"
			_tmp3_ = _device_it;
#line 339 "../src/Services/Manager.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 339 "../src/Services/Manager.vala"
				break;
#line 3591 "Manager.c"
			}
#line 339 "../src/Services/Manager.vala"
			_tmp4_ = _device_it;
#line 339 "../src/Services/Manager.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 339 "../src/Services/Manager.vala"
			device = (BluetoothServicesDevice*) _tmp5_;
#line 340 "../src/Services/Manager.vala"
			_tmp6_ = device;
#line 340 "../src/Services/Manager.vala"
			_tmp7_ = bluetooth_services_device_get_connected (_tmp6_);
#line 340 "../src/Services/Manager.vala"
			_tmp8_ = _tmp7_;
#line 340 "../src/Services/Manager.vala"
			if (_tmp8_) {
#line 341 "../src/Services/Manager.vala"
				result = TRUE;
#line 341 "../src/Services/Manager.vala"
				_g_object_unref0 (device);
#line 341 "../src/Services/Manager.vala"
				_g_object_unref0 (_device_it);
#line 341 "../src/Services/Manager.vala"
				_g_object_unref0 (devices);
#line 341 "../src/Services/Manager.vala"
				return result;
#line 3617 "Manager.c"
			}
#line 339 "../src/Services/Manager.vala"
			_g_object_unref0 (device);
#line 3621 "Manager.c"
		}
#line 339 "../src/Services/Manager.vala"
		_g_object_unref0 (_device_it);
#line 3625 "Manager.c"
	}
#line 345 "../src/Services/Manager.vala"
	result = FALSE;
#line 345 "../src/Services/Manager.vala"
	_g_object_unref0 (devices);
#line 345 "../src/Services/Manager.vala"
	return result;
#line 3633 "Manager.c"
}

gboolean
bluetooth_services_object_manager_get_global_state (BluetoothServicesObjectManager* self)
{
	GeeLinkedList* adapters = NULL;
	GeeLinkedList* _tmp0_;
	gboolean result;
#line 348 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 349 "../src/Services/Manager.vala"
	_tmp0_ = bluetooth_services_object_manager_get_adapters (self);
#line 349 "../src/Services/Manager.vala"
	adapters = _tmp0_;
#line 3648 "Manager.c"
	{
		GeeLinkedList* _adapter_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _adapter_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _adapter_index = 0;
#line 350 "../src/Services/Manager.vala"
		_tmp1_ = adapters;
#line 350 "../src/Services/Manager.vala"
		_adapter_list = _tmp1_;
#line 350 "../src/Services/Manager.vala"
		_tmp2_ = _adapter_list;
#line 350 "../src/Services/Manager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 350 "../src/Services/Manager.vala"
		_tmp4_ = _tmp3_;
#line 350 "../src/Services/Manager.vala"
		_adapter_size = _tmp4_;
#line 350 "../src/Services/Manager.vala"
		_adapter_index = -1;
#line 350 "../src/Services/Manager.vala"
		while (TRUE) {
#line 3673 "Manager.c"
			gint _tmp5_;
			gint _tmp6_;
			BluetoothServicesAdapter* adapter = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			BluetoothServicesAdapter* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 350 "../src/Services/Manager.vala"
			_adapter_index = _adapter_index + 1;
#line 350 "../src/Services/Manager.vala"
			_tmp5_ = _adapter_index;
#line 350 "../src/Services/Manager.vala"
			_tmp6_ = _adapter_size;
#line 350 "../src/Services/Manager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 350 "../src/Services/Manager.vala"
				break;
#line 3692 "Manager.c"
			}
#line 350 "../src/Services/Manager.vala"
			_tmp7_ = _adapter_list;
#line 350 "../src/Services/Manager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _adapter_index);
#line 350 "../src/Services/Manager.vala"
			adapter = (BluetoothServicesAdapter*) _tmp8_;
#line 351 "../src/Services/Manager.vala"
			_tmp9_ = adapter;
#line 351 "../src/Services/Manager.vala"
			_tmp10_ = bluetooth_services_adapter_get_powered (_tmp9_);
#line 351 "../src/Services/Manager.vala"
			_tmp11_ = _tmp10_;
#line 351 "../src/Services/Manager.vala"
			if (_tmp11_) {
#line 352 "../src/Services/Manager.vala"
				result = TRUE;
#line 352 "../src/Services/Manager.vala"
				_g_object_unref0 (adapter);
#line 352 "../src/Services/Manager.vala"
				_g_object_unref0 (adapters);
#line 352 "../src/Services/Manager.vala"
				return result;
#line 3716 "Manager.c"
			}
#line 350 "../src/Services/Manager.vala"
			_g_object_unref0 (adapter);
#line 3720 "Manager.c"
		}
	}
#line 356 "../src/Services/Manager.vala"
	result = FALSE;
#line 356 "../src/Services/Manager.vala"
	_g_object_unref0 (adapters);
#line 356 "../src/Services/Manager.vala"
	return result;
#line 3729 "Manager.c"
}

static void
bluetooth_services_object_manager_set_global_state_data_free (gpointer _data)
{
	BluetoothServicesObjectManagerSetGlobalStateData* _data_;
	_data_ = _data;
#line 28 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../src/Services/Manager.vala"
	g_slice_free (BluetoothServicesObjectManagerSetGlobalStateData, _data_);
#line 3741 "Manager.c"
}

void
bluetooth_services_object_manager_set_global_state (BluetoothServicesObjectManager* self,
                                                    gboolean state,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	BluetoothServicesObjectManagerSetGlobalStateData* _data_;
	BluetoothServicesObjectManager* _tmp0_;
#line 28 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Services/Manager.vala"
	_data_ = g_slice_new0 (BluetoothServicesObjectManagerSetGlobalStateData);
#line 28 "../src/Services/Manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../src/Services/Manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_services_object_manager_set_global_state_data_free);
#line 28 "../src/Services/Manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../src/Services/Manager.vala"
	_data_->self = _tmp0_;
#line 28 "../src/Services/Manager.vala"
	_data_->state = state;
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_global_state_co (_data_);
#line 3768 "Manager.c"
}

void
bluetooth_services_object_manager_set_global_state_finish (BluetoothServicesObjectManager* self,
                                                           GAsyncResult* _res_)
{
	BluetoothServicesObjectManagerSetGlobalStateData* _data_;
#line 28 "../src/Services/Manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3778 "Manager.c"
}

static void
bluetooth_services_object_manager_set_global_state_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	BluetoothServicesObjectManagerSetGlobalStateData* _data_;
#line 369 "../src/Services/Manager.vala"
	_data_ = _user_data_;
#line 369 "../src/Services/Manager.vala"
	_data_->_source_object_ = source_object;
#line 369 "../src/Services/Manager.vala"
	_data_->_res_ = _res_;
#line 369 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_global_state_co (_data_);
#line 3795 "Manager.c"
}

static gboolean
bluetooth_services_object_manager_set_global_state_co (BluetoothServicesObjectManagerSetGlobalStateData* _data_)
{
#line 359 "../src/Services/Manager.vala"
	switch (_data_->_state_) {
#line 359 "../src/Services/Manager.vala"
		case 0:
#line 3805 "Manager.c"
		goto _state_0;
#line 359 "../src/Services/Manager.vala"
		case 1:
#line 3809 "Manager.c"
		goto _state_1;
#line 359 "../src/Services/Manager.vala"
		case 2:
#line 3813 "Manager.c"
		goto _state_2;
		default:
#line 359 "../src/Services/Manager.vala"
		g_assert_not_reached ();
#line 3818 "Manager.c"
	}
	_state_0:
#line 360 "../src/Services/Manager.vala"
	_data_->_tmp2_ = _data_->self->priv->_is_powered;
#line 360 "../src/Services/Manager.vala"
	if (_data_->state == _data_->_tmp2_) {
#line 360 "../src/Services/Manager.vala"
		_data_->_tmp3_ = _data_->self->priv->_discoverable;
#line 360 "../src/Services/Manager.vala"
		_data_->_tmp1_ = _data_->_tmp3_ == _data_->state;
#line 3829 "Manager.c"
	} else {
#line 360 "../src/Services/Manager.vala"
		_data_->_tmp1_ = FALSE;
#line 3833 "Manager.c"
	}
#line 360 "../src/Services/Manager.vala"
	if (_data_->_tmp1_) {
#line 360 "../src/Services/Manager.vala"
		_data_->_tmp4_ = _data_->self->priv->_is_discovering;
#line 360 "../src/Services/Manager.vala"
		_data_->_tmp0_ = _data_->_tmp4_ == _data_->state;
#line 3841 "Manager.c"
	} else {
#line 360 "../src/Services/Manager.vala"
		_data_->_tmp0_ = FALSE;
#line 3845 "Manager.c"
	}
#line 360 "../src/Services/Manager.vala"
	if (_data_->_tmp0_) {
#line 361 "../src/Services/Manager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 361 "../src/Services/Manager.vala"
		if (_data_->_state_ != 0) {
#line 361 "../src/Services/Manager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 361 "../src/Services/Manager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3857 "Manager.c"
			}
		}
#line 361 "../src/Services/Manager.vala"
		g_object_unref (_data_->_async_result);
#line 361 "../src/Services/Manager.vala"
		return FALSE;
#line 3864 "Manager.c"
	}
#line 365 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_discoverable (_data_->self, _data_->state);
#line 366 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_set_is_powered (_data_->self, _data_->state);
#line 368 "../src/Services/Manager.vala"
	if (!_data_->state) {
#line 369 "../src/Services/Manager.vala"
		_data_->_state_ = 1;
#line 369 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_stop_discovery (_data_->self, bluetooth_services_object_manager_set_global_state_ready, _data_);
#line 369 "../src/Services/Manager.vala"
		return FALSE;
#line 3878 "Manager.c"
		_state_1:
#line 369 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_stop_discovery_finish (_data_->self, _data_->_res_);
#line 3882 "Manager.c"
	}
#line 372 "../src/Services/Manager.vala"
	_data_->_tmp5_ = bluetooth_services_object_manager_get_adapters (_data_->self);
#line 372 "../src/Services/Manager.vala"
	_data_->adapters = _data_->_tmp5_;
#line 3888 "Manager.c"
	{
#line 373 "../src/Services/Manager.vala"
		_data_->_tmp6_ = _data_->adapters;
#line 373 "../src/Services/Manager.vala"
		_data_->_adapter_list = _data_->_tmp6_;
#line 373 "../src/Services/Manager.vala"
		_data_->_tmp7_ = _data_->_adapter_list;
#line 373 "../src/Services/Manager.vala"
		_data_->_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp7_);
#line 373 "../src/Services/Manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 373 "../src/Services/Manager.vala"
		_data_->_adapter_size = _data_->_tmp9_;
#line 373 "../src/Services/Manager.vala"
		_data_->_adapter_index = -1;
#line 373 "../src/Services/Manager.vala"
		while (TRUE) {
#line 373 "../src/Services/Manager.vala"
			_data_->_adapter_index = _data_->_adapter_index + 1;
#line 373 "../src/Services/Manager.vala"
			_data_->_tmp10_ = _data_->_adapter_index;
#line 373 "../src/Services/Manager.vala"
			_data_->_tmp11_ = _data_->_adapter_size;
#line 373 "../src/Services/Manager.vala"
			if (!(_data_->_tmp10_ < _data_->_tmp11_)) {
#line 373 "../src/Services/Manager.vala"
				break;
#line 3916 "Manager.c"
			}
#line 373 "../src/Services/Manager.vala"
			_data_->_tmp12_ = _data_->_adapter_list;
#line 373 "../src/Services/Manager.vala"
			_data_->_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp12_, _data_->_adapter_index);
#line 373 "../src/Services/Manager.vala"
			_data_->adapter = (BluetoothServicesAdapter*) _data_->_tmp13_;
#line 374 "../src/Services/Manager.vala"
			_data_->_tmp14_ = _data_->adapter;
#line 374 "../src/Services/Manager.vala"
			bluetooth_services_adapter_set_powered (_data_->_tmp14_, _data_->state);
#line 375 "../src/Services/Manager.vala"
			_data_->_tmp15_ = _data_->adapter;
#line 375 "../src/Services/Manager.vala"
			bluetooth_services_adapter_set_discoverable (_data_->_tmp15_, _data_->state);
#line 373 "../src/Services/Manager.vala"
			_g_object_unref0 (_data_->adapter);
#line 3934 "Manager.c"
		}
	}
#line 378 "../src/Services/Manager.vala"
	_data_->_tmp16_ = _data_->self->priv->settings;
#line 378 "../src/Services/Manager.vala"
	if (_data_->_tmp16_ != NULL) {
#line 379 "../src/Services/Manager.vala"
		_data_->_tmp17_ = _data_->self->priv->settings;
#line 379 "../src/Services/Manager.vala"
		g_settings_set_boolean (_data_->_tmp17_, "bluetooth-enabled", _data_->state);
#line 3945 "Manager.c"
	}
#line 382 "../src/Services/Manager.vala"
	if (!_data_->state) {
#line 383 "../src/Services/Manager.vala"
		_data_->_tmp18_ = bluetooth_services_object_manager_get_devices (_data_->self);
#line 383 "../src/Services/Manager.vala"
		_data_->devices = _data_->_tmp18_;
#line 3953 "Manager.c"
		{
#line 384 "../src/Services/Manager.vala"
			_data_->_tmp19_ = _data_->devices;
#line 384 "../src/Services/Manager.vala"
			_data_->_tmp20_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp19_);
#line 384 "../src/Services/Manager.vala"
			_data_->_device_it = _data_->_tmp20_;
#line 384 "../src/Services/Manager.vala"
			while (TRUE) {
#line 384 "../src/Services/Manager.vala"
				_data_->_tmp21_ = _data_->_device_it;
#line 384 "../src/Services/Manager.vala"
				if (!gee_iterator_next (_data_->_tmp21_)) {
#line 384 "../src/Services/Manager.vala"
					break;
#line 3969 "Manager.c"
				}
#line 384 "../src/Services/Manager.vala"
				_data_->_tmp22_ = _data_->_device_it;
#line 384 "../src/Services/Manager.vala"
				_data_->_tmp23_ = gee_iterator_get (_data_->_tmp22_);
#line 384 "../src/Services/Manager.vala"
				_data_->device = (BluetoothServicesDevice*) _data_->_tmp23_;
#line 385 "../src/Services/Manager.vala"
				_data_->_tmp24_ = _data_->device;
#line 385 "../src/Services/Manager.vala"
				_data_->_tmp25_ = bluetooth_services_device_get_connected (_data_->_tmp24_);
#line 385 "../src/Services/Manager.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 385 "../src/Services/Manager.vala"
				if (_data_->_tmp26_) {
#line 3985 "Manager.c"
					{
#line 387 "../src/Services/Manager.vala"
						_data_->_tmp27_ = _data_->device;
#line 387 "../src/Services/Manager.vala"
						_data_->_state_ = 2;
#line 387 "../src/Services/Manager.vala"
						bluetooth_services_device_disconnect (_data_->_tmp27_, bluetooth_services_object_manager_set_global_state_ready, _data_);
#line 387 "../src/Services/Manager.vala"
						return FALSE;
#line 3995 "Manager.c"
						_state_2:
#line 387 "../src/Services/Manager.vala"
						bluetooth_services_device_disconnect_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error0_);
#line 387 "../src/Services/Manager.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4001 "Manager.c"
							goto __catch0_g_error;
						}
					}
					goto __finally0;
					__catch0_g_error:
					{
#line 386 "../src/Services/Manager.vala"
						_data_->e = _data_->_inner_error0_;
#line 386 "../src/Services/Manager.vala"
						_data_->_inner_error0_ = NULL;
#line 389 "../src/Services/Manager.vala"
						_data_->_tmp28_ = _data_->e;
#line 389 "../src/Services/Manager.vala"
						_data_->_tmp29_ = _data_->_tmp28_->message;
#line 389 "../src/Services/Manager.vala"
						g_critical ("Manager.vala:389: %s", _data_->_tmp29_);
#line 386 "../src/Services/Manager.vala"
						_g_error_free0 (_data_->e);
#line 4020 "Manager.c"
					}
					__finally0:
#line 386 "../src/Services/Manager.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 386 "../src/Services/Manager.vala"
						_g_object_unref0 (_data_->device);
#line 386 "../src/Services/Manager.vala"
						_g_object_unref0 (_data_->_device_it);
#line 386 "../src/Services/Manager.vala"
						_g_object_unref0 (_data_->devices);
#line 386 "../src/Services/Manager.vala"
						_g_object_unref0 (_data_->adapters);
#line 386 "../src/Services/Manager.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 386 "../src/Services/Manager.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 386 "../src/Services/Manager.vala"
						g_object_unref (_data_->_async_result);
#line 386 "../src/Services/Manager.vala"
						return FALSE;
#line 4041 "Manager.c"
					}
				}
#line 384 "../src/Services/Manager.vala"
				_g_object_unref0 (_data_->device);
#line 4046 "Manager.c"
			}
#line 384 "../src/Services/Manager.vala"
			_g_object_unref0 (_data_->_device_it);
#line 4050 "Manager.c"
		}
#line 382 "../src/Services/Manager.vala"
		_g_object_unref0 (_data_->devices);
#line 4054 "Manager.c"
	} else {
#line 394 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_start_discovery (_data_->self, NULL, NULL);
#line 4058 "Manager.c"
	}
#line 359 "../src/Services/Manager.vala"
	_g_object_unref0 (_data_->adapters);
#line 359 "../src/Services/Manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 359 "../src/Services/Manager.vala"
	if (_data_->_state_ != 0) {
#line 359 "../src/Services/Manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 359 "../src/Services/Manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4070 "Manager.c"
		}
	}
#line 359 "../src/Services/Manager.vala"
	g_object_unref (_data_->_async_result);
#line 359 "../src/Services/Manager.vala"
	return FALSE;
#line 4077 "Manager.c"
}

BluetoothServicesObjectManager*
bluetooth_services_object_manager_construct (GType object_type)
{
	BluetoothServicesObjectManager * self = NULL;
#line 28 "../src/Services/Manager.vala"
	self = (BluetoothServicesObjectManager*) g_object_new (object_type, NULL);
#line 28 "../src/Services/Manager.vala"
	return self;
#line 4088 "Manager.c"
}

BluetoothServicesObjectManager*
bluetooth_services_object_manager_new (void)
{
#line 28 "../src/Services/Manager.vala"
	return bluetooth_services_object_manager_construct (BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER);
#line 4096 "Manager.c"
}

gboolean
bluetooth_services_object_manager_get_discoverable (BluetoothServicesObjectManager* self)
{
	gboolean result;
#line 35 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/Services/Manager.vala"
	result = self->priv->_discoverable;
#line 35 "../src/Services/Manager.vala"
	return result;
#line 4109 "Manager.c"
}

void
bluetooth_services_object_manager_set_discoverable (BluetoothServicesObjectManager* self,
                                                    gboolean value)
{
	gboolean old_value;
#line 35 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Services/Manager.vala"
	old_value = bluetooth_services_object_manager_get_discoverable (self);
#line 35 "../src/Services/Manager.vala"
	if (old_value != value) {
#line 35 "../src/Services/Manager.vala"
		self->priv->_discoverable = value;
#line 35 "../src/Services/Manager.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_DISCOVERABLE_PROPERTY]);
#line 4127 "Manager.c"
	}
}

gboolean
bluetooth_services_object_manager_get_has_object (BluetoothServicesObjectManager* self)
{
	gboolean result;
#line 36 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Services/Manager.vala"
	result = self->priv->_has_object;
#line 36 "../src/Services/Manager.vala"
	return result;
#line 4141 "Manager.c"
}

static void
bluetooth_services_object_manager_set_has_object (BluetoothServicesObjectManager* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 36 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Services/Manager.vala"
	old_value = bluetooth_services_object_manager_get_has_object (self);
#line 36 "../src/Services/Manager.vala"
	if (old_value != value) {
#line 36 "../src/Services/Manager.vala"
		self->priv->_has_object = value;
#line 36 "../src/Services/Manager.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_HAS_OBJECT_PROPERTY]);
#line 4159 "Manager.c"
	}
}

gboolean
bluetooth_services_object_manager_get_retrieve_finished (BluetoothServicesObjectManager* self)
{
	gboolean result;
#line 37 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../src/Services/Manager.vala"
	result = self->priv->_retrieve_finished;
#line 37 "../src/Services/Manager.vala"
	return result;
#line 4173 "Manager.c"
}

static void
bluetooth_services_object_manager_set_retrieve_finished (BluetoothServicesObjectManager* self,
                                                         gboolean value)
{
	gboolean old_value;
#line 37 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Services/Manager.vala"
	old_value = bluetooth_services_object_manager_get_retrieve_finished (self);
#line 37 "../src/Services/Manager.vala"
	if (old_value != value) {
#line 37 "../src/Services/Manager.vala"
		self->priv->_retrieve_finished = value;
#line 37 "../src/Services/Manager.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_RETRIEVE_FINISHED_PROPERTY]);
#line 4191 "Manager.c"
	}
}

gboolean
bluetooth_services_object_manager_get_is_discovering (BluetoothServicesObjectManager* self)
{
	gboolean result;
#line 39 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/Services/Manager.vala"
	result = self->priv->_is_discovering;
#line 39 "../src/Services/Manager.vala"
	return result;
#line 4205 "Manager.c"
}

static void
bluetooth_services_object_manager_set_is_discovering (BluetoothServicesObjectManager* self,
                                                      gboolean value)
{
	gboolean old_value;
#line 39 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Services/Manager.vala"
	old_value = bluetooth_services_object_manager_get_is_discovering (self);
#line 39 "../src/Services/Manager.vala"
	if (old_value != value) {
#line 39 "../src/Services/Manager.vala"
		self->priv->_is_discovering = value;
#line 39 "../src/Services/Manager.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_DISCOVERING_PROPERTY]);
#line 4223 "Manager.c"
	}
}

gboolean
bluetooth_services_object_manager_get_is_powered (BluetoothServicesObjectManager* self)
{
	gboolean result;
#line 40 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/Services/Manager.vala"
	result = self->priv->_is_powered;
#line 40 "../src/Services/Manager.vala"
	return result;
#line 4237 "Manager.c"
}

static void
bluetooth_services_object_manager_set_is_powered (BluetoothServicesObjectManager* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 40 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Services/Manager.vala"
	old_value = bluetooth_services_object_manager_get_is_powered (self);
#line 40 "../src/Services/Manager.vala"
	if (old_value != value) {
#line 40 "../src/Services/Manager.vala"
		self->priv->_is_powered = value;
#line 40 "../src/Services/Manager.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_POWERED_PROPERTY]);
#line 4255 "Manager.c"
	}
}

gboolean
bluetooth_services_object_manager_get_is_connected (BluetoothServicesObjectManager* self)
{
	gboolean result;
#line 41 "../src/Services/Manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/Services/Manager.vala"
	result = self->priv->_is_connected;
#line 41 "../src/Services/Manager.vala"
	return result;
#line 4269 "Manager.c"
}

static void
bluetooth_services_object_manager_set_is_connected (BluetoothServicesObjectManager* self,
                                                    gboolean value)
{
	gboolean old_value;
#line 41 "../src/Services/Manager.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Services/Manager.vala"
	old_value = bluetooth_services_object_manager_get_is_connected (self);
#line 41 "../src/Services/Manager.vala"
	if (old_value != value) {
#line 41 "../src/Services/Manager.vala"
		self->priv->_is_connected = value;
#line 41 "../src/Services/Manager.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_CONNECTED_PROPERTY]);
#line 4287 "Manager.c"
	}
}

static gboolean
__lambda22_ (BluetoothServicesObjectManager* self,
             BluetoothServicesAdapter* adapter)
{
	gboolean _tmp0_;
	gboolean result;
#line 58 "../src/Services/Manager.vala"
	g_return_val_if_fail (adapter != NULL, FALSE);
#line 58 "../src/Services/Manager.vala"
	_tmp0_ = self->priv->_discoverable;
#line 58 "../src/Services/Manager.vala"
	bluetooth_services_adapter_set_discoverable (adapter, _tmp0_);
#line 58 "../src/Services/Manager.vala"
	result = _tmp0_;
#line 58 "../src/Services/Manager.vala"
	_g_object_unref0 (adapter);
#line 58 "../src/Services/Manager.vala"
	return result;
#line 4309 "Manager.c"
}

static gboolean
___lambda22__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = __lambda22_ ((BluetoothServicesObjectManager*) self, (BluetoothServicesAdapter*) g);
#line 58 "../src/Services/Manager.vala"
	return result;
#line 4320 "Manager.c"
}

static void
_bluetooth_services_object_manager___lambda21_ (BluetoothServicesObjectManager* self)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 58 "../src/Services/Manager.vala"
	_tmp0_ = bluetooth_services_object_manager_get_adapters (self);
#line 58 "../src/Services/Manager.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Services/Manager.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp1_, ___lambda22__gee_forall_func, self);
#line 58 "../src/Services/Manager.vala"
	_g_object_unref0 (_tmp1_);
#line 4336 "Manager.c"
}

static void
__bluetooth_services_object_manager___lambda21__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 57 "../src/Services/Manager.vala"
	_bluetooth_services_object_manager___lambda21_ ((BluetoothServicesObjectManager*) self);
#line 4346 "Manager.c"
}

static GObject *
bluetooth_services_object_manager_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothServicesObjectManager * self;
	GSettingsSchema* settings_schema = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
#line 50 "../src/Services/Manager.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_services_object_manager_parent_class);
#line 50 "../src/Services/Manager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../src/Services/Manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManager);
#line 51 "../src/Services/Manager.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 51 "../src/Services/Manager.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, BLUETOOTH_SERVICES_OBJECT_MANAGER_SCHEMA, TRUE);
#line 51 "../src/Services/Manager.vala"
	settings_schema = _tmp1_;
#line 52 "../src/Services/Manager.vala"
	_tmp2_ = settings_schema;
#line 52 "../src/Services/Manager.vala"
	if (_tmp2_ != NULL) {
#line 4377 "Manager.c"
		GSettings* _tmp3_;
#line 53 "../src/Services/Manager.vala"
		_tmp3_ = g_settings_new (BLUETOOTH_SERVICES_OBJECT_MANAGER_SCHEMA);
#line 53 "../src/Services/Manager.vala"
		_g_object_unref0 (self->priv->settings);
#line 53 "../src/Services/Manager.vala"
		self->priv->settings = _tmp3_;
#line 4385 "Manager.c"
	}
#line 55 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_create_manager (self, NULL, NULL);
#line 57 "../src/Services/Manager.vala"
	g_signal_connect_object ((GObject*) self, "notify::discoverable", (GCallback) __bluetooth_services_object_manager___lambda21__g_object_notify, self, 0);
#line 50 "../src/Services/Manager.vala"
	_g_settings_schema_unref0 (settings_schema);
#line 50 "../src/Services/Manager.vala"
	return obj;
#line 4395 "Manager.c"
}

static void
bluetooth_services_object_manager_class_init (BluetoothServicesObjectManagerClass * klass,
                                              gpointer klass_data)
{
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/Services/Manager.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothServicesObjectManager_private_offset);
#line 28 "../src/Services/Manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_services_object_manager_get_property;
#line 28 "../src/Services/Manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_services_object_manager_set_property;
#line 28 "../src/Services/Manager.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_services_object_manager_constructor;
#line 28 "../src/Services/Manager.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_services_object_manager_finalize;
#line 28 "../src/Services/Manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_OBJECT_MANAGER_DISCOVERABLE_PROPERTY, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_DISCOVERABLE_PROPERTY] = g_param_spec_boolean ("discoverable", "discoverable", "discoverable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/Services/Manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_OBJECT_MANAGER_HAS_OBJECT_PROPERTY, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_HAS_OBJECT_PROPERTY] = g_param_spec_boolean ("has-object", "has-object", "has-object", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/Services/Manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_OBJECT_MANAGER_RETRIEVE_FINISHED_PROPERTY, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_RETRIEVE_FINISHED_PROPERTY] = g_param_spec_boolean ("retrieve-finished", "retrieve-finished", "retrieve-finished", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/Services/Manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_DISCOVERING_PROPERTY, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_DISCOVERING_PROPERTY] = g_param_spec_boolean ("is-discovering", "is-discovering", "is-discovering", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/Services/Manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_POWERED_PROPERTY, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_POWERED_PROPERTY] = g_param_spec_boolean ("is-powered", "is-powered", "is-powered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/Services/Manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_CONNECTED_PROPERTY, bluetooth_services_object_manager_properties[BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_CONNECTED_PROPERTY] = g_param_spec_boolean ("is-connected", "is-connected", "is-connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_ADAPTER_ADDED_SIGNAL] = g_signal_new ("adapter-added", BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BLUETOOTH_SERVICES_TYPE_ADAPTER);
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_ADAPTER_REMOVED_SIGNAL] = g_signal_new ("adapter-removed", BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BLUETOOTH_SERVICES_TYPE_ADAPTER);
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_DEVICE_ADDED_SIGNAL] = g_signal_new ("device-added", BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BLUETOOTH_SERVICES_TYPE_DEVICE);
#line 28 "../src/Services/Manager.vala"
	bluetooth_services_object_manager_signals[BLUETOOTH_SERVICES_OBJECT_MANAGER_DEVICE_REMOVED_SIGNAL] = g_signal_new ("device-removed", BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, BLUETOOTH_SERVICES_TYPE_DEVICE);
#line 4434 "Manager.c"
}

static void
bluetooth_services_object_manager_instance_init (BluetoothServicesObjectManager * self,
                                                 gpointer klass)
{
#line 28 "../src/Services/Manager.vala"
	self->priv = bluetooth_services_object_manager_get_instance_private (self);
#line 35 "../src/Services/Manager.vala"
	self->priv->_discoverable = FALSE;
#line 36 "../src/Services/Manager.vala"
	self->priv->_has_object = FALSE;
#line 37 "../src/Services/Manager.vala"
	self->priv->_retrieve_finished = FALSE;
#line 39 "../src/Services/Manager.vala"
	self->priv->_is_discovering = FALSE;
#line 40 "../src/Services/Manager.vala"
	self->priv->_is_powered = FALSE;
#line 41 "../src/Services/Manager.vala"
	self->priv->_is_connected = FALSE;
#line 43 "../src/Services/Manager.vala"
	self->priv->is_registered = FALSE;
#line 45 "../src/Services/Manager.vala"
	self->priv->settings = NULL;
#line 4459 "Manager.c"
}

static void
bluetooth_services_object_manager_finalize (GObject * obj)
{
	BluetoothServicesObjectManager * self;
#line 28 "../src/Services/Manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManager);
#line 45 "../src/Services/Manager.vala"
	_g_object_unref0 (self->priv->settings);
#line 46 "../src/Services/Manager.vala"
	_g_object_unref0 (self->priv->object_manager);
#line 47 "../src/Services/Manager.vala"
	_g_object_unref0 (self->priv->agent_manager);
#line 48 "../src/Services/Manager.vala"
	_g_object_unref0 (self->priv->agent);
#line 28 "../src/Services/Manager.vala"
	G_OBJECT_CLASS (bluetooth_services_object_manager_parent_class)->finalize (obj);
#line 4478 "Manager.c"
}

static GType
bluetooth_services_object_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothServicesObjectManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_services_object_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothServicesObjectManager), 0, (GInstanceInitFunc) bluetooth_services_object_manager_instance_init, NULL };
	GType bluetooth_services_object_manager_type_id;
	bluetooth_services_object_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "BluetoothServicesObjectManager", &g_define_type_info, 0);
	BluetoothServicesObjectManager_private_offset = g_type_add_instance_private (bluetooth_services_object_manager_type_id, sizeof (BluetoothServicesObjectManagerPrivate));
	return bluetooth_services_object_manager_type_id;
}

GType
bluetooth_services_object_manager_get_type (void)
{
	static volatile gsize bluetooth_services_object_manager_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_services_object_manager_type_id__once)) {
		GType bluetooth_services_object_manager_type_id;
		bluetooth_services_object_manager_type_id = bluetooth_services_object_manager_get_type_once ();
		g_once_init_leave (&bluetooth_services_object_manager_type_id__once, bluetooth_services_object_manager_type_id);
	}
	return bluetooth_services_object_manager_type_id__once;
}

static void
_vala_bluetooth_services_object_manager_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	BluetoothServicesObjectManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManager);
#line 28 "../src/Services/Manager.vala"
	switch (property_id) {
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_DISCOVERABLE_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		g_value_set_boolean (value, bluetooth_services_object_manager_get_discoverable (self));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_HAS_OBJECT_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		g_value_set_boolean (value, bluetooth_services_object_manager_get_has_object (self));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_RETRIEVE_FINISHED_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		g_value_set_boolean (value, bluetooth_services_object_manager_get_retrieve_finished (self));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_DISCOVERING_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		g_value_set_boolean (value, bluetooth_services_object_manager_get_is_discovering (self));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_POWERED_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		g_value_set_boolean (value, bluetooth_services_object_manager_get_is_powered (self));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_CONNECTED_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		g_value_set_boolean (value, bluetooth_services_object_manager_get_is_connected (self));
#line 28 "../src/Services/Manager.vala"
		break;
#line 4549 "Manager.c"
		default:
#line 28 "../src/Services/Manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/Services/Manager.vala"
		break;
#line 4555 "Manager.c"
	}
}

static void
_vala_bluetooth_services_object_manager_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	BluetoothServicesObjectManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManager);
#line 28 "../src/Services/Manager.vala"
	switch (property_id) {
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_DISCOVERABLE_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_discoverable (self, g_value_get_boolean (value));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_HAS_OBJECT_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_has_object (self, g_value_get_boolean (value));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_RETRIEVE_FINISHED_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_retrieve_finished (self, g_value_get_boolean (value));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_DISCOVERING_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_is_discovering (self, g_value_get_boolean (value));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_POWERED_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_is_powered (self, g_value_get_boolean (value));
#line 28 "../src/Services/Manager.vala"
		break;
#line 28 "../src/Services/Manager.vala"
		case BLUETOOTH_SERVICES_OBJECT_MANAGER_IS_CONNECTED_PROPERTY:
#line 28 "../src/Services/Manager.vala"
		bluetooth_services_object_manager_set_is_connected (self, g_value_get_boolean (value));
#line 28 "../src/Services/Manager.vala"
		break;
#line 4605 "Manager.c"
		default:
#line 28 "../src/Services/Manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/Services/Manager.vala"
		break;
#line 4611 "Manager.c"
	}
}

